	page	240, 132
;D16EXT.ASM	17-JAN-2002
;External routines for D16.XPL
;(16-bit XPL has a difficult time simulating carry and overflow status.)

	public	doadd, doadc, dosub, dosbc

	.186
cseg	segment dword public 'code'
	assume cs:cseg

;-------------------------------------------------------------------------------
;Add Value to Acc
; DOADD(addr Acc, addr Flags, Value);
; Register usage:
;  si = Acc
;  di = Flags
;  bx = Value
;
doadd:	pop	ax		;get return address
	pop	dx
	pop	bx		;Value
	pop	di		;pointer to Flags
	pop	si		;pointer to Acc
	push	dx		;restore return address
	push	ax

	xor	dx, dx
	add	[si], bx	;do operation

;Common code
docom:	pushf			;get status bits
	pop	ax
	shl	ax, 5		;shift overflow bit into carry position
	rcl	dx, 1		;shift in overflow bit
	
	shl	ax, 11		;shift original carry bit into carry position
	rcl	dx, 1		;shift in carry
	mov	[di], dx	;store it into flags
	retf

;-------------------------------------------------------------------------------
;Add Value to Acc with carry in
; DOADC(addr Acc, addr Flags, Value);
; Register usage:
;  si = Acc
;  di = Flags
;  bx = Value
;
doadc:	pop	ax		;get return address
	pop	dx
	pop	bx		;Value
	pop	di		;pointer to Flags
	pop	si		;pointer to Acc
	push	dx		;restore return address
	push	ax

	xor	dx, dx
	mov	ah, [di]	;get carry bit from Flags
	sahf			;set carry bit accordingly

	adc	[si], bx	;do operation
	jmp	docom		;do common code and return

;-------------------------------------------------------------------------------
;Subtract Value from Acc
; DOSUB(addr Acc, addr Flags, Value);
; Register usage:
;  si = Acc
;  di = Flags
;  bx = Value
;
dosub:	pop	ax		;get return address
	pop	dx
	pop	bx		;Value
	pop	di		;pointer to Flags
	pop	si		;pointer to Acc
	push	dx		;restore return address
	push	ax

	xor	dx, dx
	sub	[si], bx	;do operation
	jmp	docom		;do common code and return

;-------------------------------------------------------------------------------
;Subtract Value from Acc with borrow
; DOSBC(addr Acc, addr Flags, Value);
; Register usage:
;  si = Acc
;  di = Flags
;  bx = Value
;
dosbc:	pop	ax		;get return address
	pop	dx
	pop	bx		;Value
	pop	di		;pointer to Flags
	pop	si		;pointer to Acc
	push	dx		;restore return address
	push	ax

	xor	dx, dx
	mov	ah, [di]	;get carry bit from Flags
	sahf			;set carry bit accordingly

	sbb	[si], bx	;do operation
	jmp	docom		;do common code and return

cseg	ends
	end
