\D16XPLX.XPL	18-APR-2005
\Optimizing XPL0 Compiler for the D16/M
\Copyright 1984-2005 P.J.R. Boyle
\The XPL0 language and compiler are based on an example in "Algorithms + Data
\ Structures = Programs" (1976 edition) by Niklaus Wirth
\IBM Native Language and Optimization version by Larry Fish
\Modified XPLX V2.4.7 to generate code for John Doran's D16/M, Loren Blaney
\
\This program is free software; you can redistribute it and/or modify it under
\ the terms of the GNU General Public License version 2 as published by the
\ Free Software Foundation.
\This program is distributed in the hope that it will be useful, but WITHOUT
\ ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
\ FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
\ details.
\You should have received a copy of the GNU General Public License along with
\ this program (in the file LICENSE.TXT); if not, write to the Free Software
\ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
\
\You can reach the authors at: loren_blaney@idcomm.com
\
\Compile this program with either XPLX (xx.bat) or XPLNQ (xn.bat)

\The required "intrinsic" routines:
code	ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
	EXTEND=5,	CHIN=7,		CHOUT=8,	CRLF=9,
	INTIN=10,	INTOUT=11,	TEXT=12,	OPENI=13,
	OPENO=14,	CLOSE=15,	TRAP=17,	GETERR=22,
	HEXOUT=27,	FSET=24,	FOPEN=29,	FCLOSE=32,
	GETREG=35,	BLIT=36,	PEEK=37;
code real		FLOAT=49,	RLRES=46;

def	SYMAX=1600,	\maximum number of symbols in the symbol table
	SIGCHAR=16,	\number of significant characters in an identifer
	HASHMSK=$FF,	\mask for hash codes
	EMTPNT=-1,	\empty symbol pointer value
	BOXNUM=256,	\number of hash boxes
	RLMAX=160,	\maximum number of entries in real-constant symbol table
	RLSIZE=8,	\number of bytes in a real number
	QUITMAX=160,	\maximum number of 'quit's in a 'loop'
	HANMAX=8,	\maximum nesting depth of include files (max. handles)
	STKMAX=100,	\maximum number of items on pseudo stack
	LEVELMAX=8;	\maximum number of static levels (0 thru LEVELMAX-1)

def	TV=0, KB=0, NULDEV=7;			\some I/O device numbers
def	BEL=$07, EOL=$0A, EOF=$1A;		\control characters

int	ACIMM,		\flag: AC register contains immediate value in ACVAL
	ACVAL,		\immediate value currently in AC (if ACIMM is true)
	ACLEV,		\the AC register contains the value of a variable
	ACOFF,		\ at this level and offset
	HAVENEST;	\flag: the current procedure has a proc nested in it

int	PSTKPTR,	\stack pointer for the following stacks (push=sto,inc)
	PSTKTYP,	\pseudo stack: holds stack operand type
	PSTKLEV,	\pseudo stack: holds level of addr operand or imm value
	PSTKOFF;	\pseudo stack: holds offset of addr operand or ^C or ^L
def	\types of pseudo-stack arguments:
	REGTYP,		\TOS is in register AC
	STKTYP,		\TOS is on H/W stack
	ADRTYP,		\TOS is in address (level, offset)
	IMMTYP,		\TOS is immediate value (^C=normal constant; ^L=label)
	REALTYP;	\TOS is a real on the H/W stack

int	COMFLG,		\switch (/C): put I2L comments into output .asm file
	DEBUG,		\switch (/D): put source code into output .asm file
	SHORTBOOL,	\switch (/B): use short-circuit boolean evaluation

	CODCTR,		\used to see if there is any code in the Main procedure
	OLDCODCTR,	\used to control CR LF for debug (/D) listing
	HASMAIN,	\flag: there is a statement in the Main procedure
	CONDITIONAL,	\flag: conditional compile ('cond')
	LOCAL,		\local label number: unique number to distinguish labels
	OLDLEV,		\old static level (for determining when to load IY reg)
	INHAND,		\input file handle
	OUTHAND;	\output file handle
char	FNAME;		\name part of input file (excluding drive and pathname)
			\ (assigns unique names to procedure code segments)
int	ERRCNT,		\compile-error counter
	LSTDEV,		\listing output device number
	SRCDEV,		\source input device number
	BINDEV,		\binary (.asm) output device number
	CHAR,		\current character.  Most of the time this contains
			\ the terminator of the current atom
	ATOM,		\present atom descriptor
			\contains reserved word hash or the ASCII for a special
			\ character; 0 if the atom is a constant or identifier
	ATYPE;		\present atom type descriptor
def	\ATYPE\ SPECIAL, IDENTIFIER, INTCON, REALCON;
char	IDENT;		\array--current identifier name
int	HASH,		\current identifier hash code
	LABCNT,		\label counter (Lxx:)
	IATOM;		\value of current integer constant
real	RLATOM;		\real constant from proc RATOM

int	IDTYPE;		\present identifier type descriptor
def	UNDEF=0,	\undefined ID (no. the order here is critical)
	ADDRVAR=1,	\address variable ID (type = integer)
	INVAR=3,	\integer variable ID (odd numbers = integer)
	RLVAR=4,	\real variable ID
	INCON=5,	\integer constant ID
	RLCON=6,	\real constant ID
	INPROC=7,	\integer procedure ID
	RLPROC=8,	\real procedure ID
	INFPROC=9,	\integer forward procedure ID
	RLFPROC=10,	\real forward procedure ID
	INOPT=11,	\integer optimized procedure ID
	RLOPT=12,	\real optimized procedure ID
	INEPRO=13,	\integer XPL external procedure
	RLEPRO=14,	\real XPL external procedure
	ININT=15,	\integer intrinsic ID
	RLINT=16,	\real intrinsic ID
	INEXT=17,	\integer external procedure ID
	RLEXT=18,	\real external procedure ID
	INSEG=19,	\integer segment variable ID
	RLSEG=20,	\real segment variable ID
	ADSEG=21,	\address variable ID
	SHSEG=22;	\short segment variable ID

int	LEV,		\static level of current identifier
	VAL,		\value or address of current identifier
	SYMNUM,		\position in SYMTBL of current identifer
	FACTYP;		\factor (or operand) type (REAL or INTEGER)
def	\FACTYP\ REAL, INTEGER;
int	PROCRETS,	\array--code labels for procedure returns for each level
	FIXES,		\array--'quit' fixes still outstanding
	LEVEL,		\static level of current procedure
	NOSYM,		\current number of symbols in symbol table
	FIXCNT,		\count of the number of outstanding 'quit's
	STKLOD,		\number of integers left on stack by 'for' or 'case'
	OPTPROC,	\boolean--generate an optimized procedure call
	NORLSY,		\current number of real constants in table
	LASTOP,		\previous opcode
	II;		\scratch for Main
char	HEXDIGIT;	\array of hex digits (0 - F)

\SYMBOL TABLE ARRAYS:
char	SYMBOL,		\identifier name (IDENT)
	SYMTYP,		\type descriptors (IDTYPE)
	SYMLEV;		\level (LEV)
int	SYMVAL,		\value or address (VAL)
	SYMPNT,		\list linkage pointers
	BOX;		\hash boxes (symbol list headers)
real	RLTBL;		\real constant table

int	HANPTR,		\pointer to old include handles
	OLDHAN;		\array of old include handles

\RESERVED WORD HASHES:
def	ADRSYM=$88E4,	BEGSYM=$84C7,	CASEYM=$8053,	CODSYM=$8184,
	DEFSYM=$9CC6,	DOSYM=$0CEF,	ELSEYM=$99F3,	ENDSYM=$99A4,
	EXITYM=$9B69,	EXTNYM=$9B74,	FALSYM=$944C,	FFUNYM=$94B5,
	FORSYM=$9592,	FPRSYM=$9672,	FUNSYM=$96CE,	GESYM=$0C85,
	GETSYM=$90D4,	IFSYM=$0D46,	INTSYM=$A9B4,	LESYM=$0DE5,
	LOOPYM=$BD8F,	NOTSYM=$B594,	OFSYM=$0D86,	PROCYM=$CE2F,
	QUITYM=$CAC9,	REALYM=$C4C1,	REPSYM=$C4D0,	RETSYM=$C4D4,
	THENYM=$DD65,	TRUSYM=$DE35,	UNTSYM=$D9B4,	WHILYM=$D169,
	CHARYM=$8161,	EPRSYM=$9A72,	EFUNYM=$98B5,	PUBSYM=$CEC2,
	OTHSYM=$B2E8,	INCSYM=$A9A3,	LSLSYM=$BE0C,	LSRSYM=$BE92,
	SEGSYM=$C0C7,	SHTSYM=$C16F,	CONSYM=$818E,	ABSSYM=$8833,
	REMSYM=$C4CD,	SWAPYM=$C281,	EXTSYM=$9B74,	PORTYM=$CD92;


func	GETBC;		\Read a char from device 8. Return EOF if end of buffer
int	C, D;
begin
for D:= 1, HANMAX do
	[C:= CHIN(8); if C#EOF then return C];
return C;
end;	\GETBC



proc	ERROR(N);	\Display error message
int	N;
int	ERR, CH, I;
char	STRING;
def	MAXERR=75;	\maximum error number
begin
ERR:= RESERVE((MAXERR+1)*2);
for I:= 0, MAXERR do ERR(I):= "? ";	\unused error numbers = "?"

ERR(0):= "UNSUPPORTED FEATURE ";
ERR(1):= "TOO MANY VARIABLES ";
ERR(2):= "TOO MANY REAL CONSTANT NAMES ";
ERR(3):= "TOO MANY NAMES ";
ERR(4):= "TOO MANY 'QUITS' ";
ERR(5):= "TOO MANY STATIC LEVELS ";
ERR(6):= "NUMBER OUT OF RANGE ";
ERR(7):= ERR(6);			\for intrinsic declarations
ERR(10):= "UNDECLARED NAME ";
ERR(11):= "NAME ALREADY DECLARED ";
ERR(20):= "ILLEGAL START OF A STATEMENT ";	\in ASSIGN
ERR(21):= "^":=^"* ";
ERR(22):= "'THEN'* ";
ERR(23):= "'DO'* ";
ERR(24):= "^",^"* ";
ERR(26):= "ILLEGAL FACTOR ";		\unrecognizable special factor
ERR(27):= "STATEMENT STARTING WITH A CONSTANT "; \in ASSIGN
ERR(28):= "'UNTIL'* ";
ERR(29):= "'OTHER'* ";
ERR(30):= "'ELSE'* ";
ERR(31):= "DIGIT* ";
ERR(33):= "INTEGER VARIABLE* ";		\in a 'for' statement
ERR(39):= "^"(^"* ";
ERR(40):= "^"=^"* ";
ERR(41):= "^";^"* ";
ERR(42):= "CONSTANT* ";			\in GETCON
ERR(43):= "VARIABLE* ";			\for an 'addr' operator
ERR(44):= "^")^"* ";
ERR(45):= "NAME* ";
ERR(46):= "MIXED MODE ";
ERR(47):= "INTEGER* ";
ERR(48):= "'OF'* ";
ERR(49):= "^":^"* ";
ERR(50):= "^"]^"* ";
ERR(51):= "NO ARGUMENTS DECLARED ";
ERR(52):= "STATEMENT STARTING WITH 'ELSE' ";
ERR(53):= "STATEMENT STARTING WITH 'OTHER' ";
ERR(60):= "'QUIT' NOT IN A 'LOOP' ";
ERR(61):= "EOF* ";
ERR(62):= "EOF INSIDE A BLOCK ";
ERR(63):= "EOF INSIDE A STRING ";
ERR(65):= "'FPROC' & ITS 'PROC' NOT AT SAME LEVEL ";
ERR(66):= "'FPROC' REFERENCE NOT FOUND ";
ERR(67):= "'PROC' OR 'FUNC'* ";
ERR(68):= "'EPROC'S AND 'PUBLIC'S MUST BE GLOBAL ";
ERR(69):= "'INCLUDE'S NESTED TOO DEEP ";
ERR(70):= "BAD FILE SPEC ";
ERR(71):= "FILE NOT FOUND ";
ERR(72):= "'INT', 'REAL', 'CHAR' or 'ADDR'* ";
ERR(73):= "DIVIDE BY ZERO IN A CONSTANT EXPRESSION ";
ERR(74):= "MATH ERROR IN A CONSTANT EXPRESSION ";
ERR(75):= "EXPRESSION MUST BE ENCLOSED IN PARENTHESES ";

if LSTDEV = 8 then
	begin
	OPENI(8);
	loop	begin
		CH:= GETBC;
		if CH=EOF then quit;
		CHOUT(TV, CH);
		end;
	CRLF(TV);
	end;

CHOUT(TV, BEL); CHOUT(TV, $0A);		\(damn linefeeds!)
CRLF(TV);
TEXT(TV, "***** ERROR NO. "); INTOUT(TV, N); TEXT(TV, " *****");
CRLF(TV);
STRING:= ERR(N);
I:= 0;
loop	[CH:= STRING(I);		\output message
	if CH>=$80 then quit;
	if CH=^* then TEXT(TV, " EXPECTED BUT NOT FOUND")
	else CHOUT(TV, CH);
	I:= I+1];
CRLF(TV);
TEXT(TV, "ATTEMPT TO CONTINUE (Y/N)? ");
OPENI(KB);
case CHIN(KB) of ^N, ^n: [CLOSE(LSTDEV); exit 1] other;
BINDEV:= NULDEV;			\there shall be no output file
ERRCNT:= ERRCNT+1;
end;	\ERROR



proc	DEBDUMP;	\Dump XPL source to assembly file for debugging (/D)
int	CH;


	func	DUMPLINE;	\Dump a line of source code
	begin
	CH:= GETBC;
	if CH=EOF then return false;
	TEXT(BINDEV, "; ");
	loop	begin
		if CH=EOF then return false;
		CHOUT(BINDEV, CH);
		if CH=EOL then return true;
		CH:= GETBC;
		end;
	end;	\DUMPLINE


begin	\DEBDUMP
if LSTDEV=8 then
	begin
	OPENI(8);
	while DUMPLINE do;
	OPENO(8);
	end;
if OLDCODCTR # CODCTR then CRLF(BINDEV);
OLDCODCTR:= CODCTR;
end;	\DEBDUMP



proc	GETCH;		\Get a character from the source device
begin
CHAR:= CHIN(SRCDEV); CHOUT(LSTDEV, CHAR);
if DEBUG then
	if CHAR=EOL then DEBDUMP;
while CHAR=^\ do			\filter out comments
	begin
	loop	begin
		CHAR:= CHIN(SRCDEV); CHOUT(LSTDEV, CHAR);
		case CHAR of
		  EOL:	[if DEBUG then DEBDUMP; quit];
		  ^\:	quit;
		  EOF:	quit
		other	;
		end;
	CHAR:= ^ ;			\a comment is a separator
	end;
end;	\GETCH

\----------------------- ROUTINES TO HANDLE INCLUDES ---------------------------

proc	FALLBACK;	\Terminate an include and fall back to previous handle
begin
HANPTR:= HANPTR-1;
FCLOSE(INHAND);
INHAND:= OLDHAN(HANPTR);
FSET(INHAND, if HANPTR=0 then ^I else ^i); \only the main file gets big buffer
end;	\FALLBACK



proc	INCLUDE;	\Set up an include file
char	NAME;
def	NAMMAX=80;
int	NEWHAND, I;


	proc	GETC;		\Get character with no filtering of comments
	begin
	CHAR:= CHIN(SRCDEV);
	CHOUT(LSTDEV, CHAR);
	end;	\GETC


	func	GETNAME;	\Read file specification
	int	EXTFLG, I, K;
	char	DEFEXT;
	begin
	DEFEXT:= ".XPL";
	EXTFLG:= false;

	while CHAR<=$20 do		\eat leading spaces and control chars
		[if CHAR=EOF then ERROR(61); GETC];

	K:= 0;				\copy file name into NAME
	loop	begin
		case CHAR of
		  ^.:	EXTFLG:= true;
		  EOL:	return false;
		  ^;:	quit
		other;

		NAME(K):= CHAR;
		K:= K+1;
		if K>=NAMMAX  then return false;
		GETC;
		end;

	if K=0 then return false;	\deal with empty file name

	if EXTFLG then			\deal with default extensions
		NAME(K-1):= NAME(K-1) ! $80
	else	begin
		if (K+4) >= NAMMAX then return false;
		for I:= 0, 3 do NAME(K+I):= DEFEXT(I);
		end;
	return true;
	end;	\GETNAME


begin	\INCLUDE
NAME:= RESERVE(NAMMAX);
if HANPTR >= HANMAX then
	[ERROR(69); while CHAR#^; & CHAR#EOF do GETC; return];
if not GETNAME then
	[ERROR(70); while CHAR#^; & CHAR#EOF do GETC; return];

TRAP($FFFB);				\open file
NEWHAND:= FOPEN(NAME, 0);
TRAP($FFFF);
if GETERR = 3 then [ERROR(71); return];

OLDHAN(HANPTR):= INHAND;		\save old file handle on stack
HANPTR:= HANPTR+1;
INHAND:= NEWHAND;

FSET(INHAND, ^i);			\include files always use small buffers

TEXT(TV, "INCLUDING: ");
for I:= 2, HANPTR do TEXT(TV, "   ");
TEXT(TV, NAME); CRLF(TV);
end;	\INCLUDE

\-------------------------------------------------------------------------------

fproc	CONEXPRESS;


proc	RATOM;		\Read an atom
\Outputs:  ATOM, ATYPE, IDENT, HASH, IATOM, CHAR, RLATOM.
int	LEN, NEG, EXP, I, INTOVF;
real	FRACT, DENOM;


	proc	RFRACT;	\Read the fractional part of a real number
	begin
	ATYPE:= REALCON; ATOM:= 0;
	GETCH;
	FRACT:= FLOAT(0); DENOM:= FLOAT(10);	\("10.0" is not as portable)
	while CHAR>=^0 & CHAR<=^9 do
		[FRACT:= FRACT +FLOAT(CHAR-^0) /DENOM;
		DENOM:= DENOM*FLOAT(10);
		GETCH];
	RLATOM:= RLATOM +FRACT;
	end;	\RFRACT


	proc	REXP;	\Read an exponent if any
	if CHAR=^E ! CHAR=^e then
		begin
		ATYPE:= REALCON;
		GETCH;
		if CHAR=^- then [NEG:= true; GETCH]
		else NEG:= false;
		if CHAR=^+ then GETCH;
		EXP:= 0;
		if CHAR<^0 ! CHAR>^9 then ERROR(31);
		while CHAR>=^0 & CHAR<=^9 do
			[EXP:= EXP *10 +CHAR-^0; GETCH];
		if NEG then EXP:= -EXP;
		while EXP>0 do
			[RLATOM:= RLATOM *FLOAT(10); EXP:= EXP-1];
		while EXP<0 do
			[RLATOM:= RLATOM /FLOAT(10); EXP:= EXP+1];
		end;	\REXP


begin	\RATOM
while CHAR<=$20 do	\skip spaces, tabs, CR's, LF's, & FF's, etc.
	begin		\ but don't go past EOF
			\if HANPTR=0 then it's a hard EOF
	if CHAR=EOF then if HANPTR>0 then FALLBACK
		    else [ATYPE:= SPECIAL; ATOM:= EOF; return];
	GETCH;
	end;
if CHAR>=^a then if CHAR<=^z then			\RESERVED WORD
	[ATYPE:= SPECIAL;
	ATOM:= CHAR; GETCH;
	ATOM:= ATOM<<5|CHAR; GETCH;
	if CHAR>=^a & CHAR<=^z then [ATOM:= ATOM<<5|CHAR; GETCH];
	while CHAR>=^a & CHAR<=^z do GETCH;
	case ATOM of
	  TRUSYM: [ATYPE:= INTCON; ATOM:= 0; IATOM:= true];
	  FALSYM: [ATYPE:= INTCON; ATOM:= 0; IATOM:= false];
	  CONSYM: begin
		  RATOM;
		  CONEXPRESS;
		  if FACTYP=INTEGER then CONDITIONAL:= IATOM else ERROR(47);
		  while ATOM=^; do RATOM;		\eat semicolon, if any
		  loop	begin				\eat atoms until cond=true
			if CONDITIONAL \#0\ then quit;
			if ATYPE=SPECIAL then
			  if ATOM=EOF then quit
			  else if ATOM=^" then		\ignore 'con' in strings
			    begin
			    loop begin
				 CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
				 if CHAR=EOF then [ERROR(63); exit 1];
				 if CHAR=^^ then
					[CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR)]
				 else	if CHAR=^" then quit;
				 end;
			    GETCH;
			    end;
			RATOM;
			end;
		  end;
	  INCSYM: [INCLUDE; GETCH; RATOM]
	other;
	return];
if CHAR>=^A then if CHAR<=^Z ! CHAR=^_ then		\IDENTIFIER
	begin
	ATYPE:= IDENTIFIER; ATOM:= 0;
	IDENT(0):= CHAR; HASH:= CHAR; GETCH;
	LEN:= 1;
	loop	begin
		if CHAR>=^a & CHAR<=^z then CHAR:= CHAR & $DF;	\uppercase
		case of
		  CHAR>=^A & CHAR<=^Z,  CHAR>=^0 & CHAR<=^9,  CHAR=^_ :
			begin
			if LEN <SIGCHAR then
				[IDENT(LEN):= CHAR;
				HASH:= HASH+CHAR;
				LEN:= LEN+1];
			GETCH;
			end
		other	quit;
		end;
	for LEN:= LEN, SIGCHAR-1 do
		[IDENT(LEN):= ^ ; HASH:= HASH+^ ];
	HASH:= HASH & HASHMSK;
	return;
	end;
if CHAR>=^0 then if CHAR<=^9 then			\UNSIGNED INTEGER
	begin
	ATYPE:= INTCON;		\assume integer until shown otherwise
	ATOM:= 0;
	INTOVF:= false;
	IATOM:= CHAR-^0; GETCH;
	loop	begin
		I:= IATOM;
		if CHAR<^0 ! CHAR>^9 then quit;
		I:= IATOM*10+CHAR-^0;
		if IATOM>3276 ! IATOM=3276 & CHAR>^7 then	\"I" overflowed
			[INTOVF:=true; quit];			\ok if it's real
		IATOM:= I;
		GETCH;
		end;
	RLATOM:= FLOAT(IATOM);
	IATOM:= I;			\(can't Float(32768))
	while CHAR>=^0 & CHAR<=^9 do	\more digits: must be a real
		[RLATOM:= RLATOM*FLOAT(10) + FLOAT(CHAR-^0);
		GETCH];
	if CHAR=^. then RFRACT;				\UNSIGNED REAL
	REXP;
	if ATYPE=INTCON & INTOVF & IATOM#$8000 then
		if CONDITIONAL then ERROR(6);
	return;
	end;
case CHAR of
  ^.:	[RLATOM:= FLOAT(0);				\UNSIGNED REAL
	RFRACT;
	REXP;
	return];
  ^$:	begin						\UNSIGNED HEX INTEGER
	ATYPE:= INTCON; ATOM:= 0;
	GETCH;
	case of
	  CHAR>=^0 & CHAR<=^9:	IATOM:= CHAR-^0;
	  CHAR>=^A & CHAR<=^F:	IATOM:= CHAR-$37;
	  CHAR>=^a & CHAR<=^f:	IATOM:=CHAR-$57
	other	[\digit expected\ ERROR(31); return];
	loop	begin
		GETCH;
		case of
		  CHAR>=^0 & CHAR<=^9:	I:= CHAR-^0;
		  CHAR>=^A & CHAR<=^F:	I:= CHAR-$37;
		  CHAR>=^a & CHAR<=^f:	I:=CHAR-$57
		other return;
		if IATOM>$FFF then
			if CONDITIONAL then ERROR(6);
		IATOM:= IATOM*16+I;
		end;
	end;
  ^^:	[ATYPE:= INTCON;				\META CHARACTER
	ATOM:= 0;					\ = integer constant
	CHAR:= CHIN(SRCDEV); CHOUT(LSTDEV, CHAR);
	IATOM:= CHAR;
	GETCH;
	return];
  ^":	[ATYPE:= SPECIAL;				\SPECIAL CHARACTER
	ATOM:= CHAR;		\' and backslash have no effect inside strings
	CHAR:= CHIN(SRCDEV); CHOUT(LSTDEV, CHAR);
	return]
other;
ATYPE:= SPECIAL;					\SPECIAL CHARACTER
ATOM:= CHAR;
GETCH;
case CHAR of
  ^=:	case ATOM of
	^::	[GETCH; ATOM:= GETSYM];
	^>:	[GETCH; ATOM:= GESYM];
	^<:	[GETCH; ATOM:= LESYM]
	other;
  ^<:	[if ATOM = ^< then [GETCH; ATOM:= LSLSYM]];
  ^>:	[if ATOM = ^> then [GETCH; ATOM:= LSRSYM]]
other;
end;	\RATOM



proc	SKIPIT;		\Skip the rest of a statement (for error recovery)
begin
while ATOM#EOF & ATOM#^; & ATOM#ENDSYM & ATOM#^] & ATOM#BEGSYM & ATOM#^[ do
	RATOM;
end;	\SKIPIT



proc	HEXB(I);	\Output hex byte
int	I;
begin
CHOUT(BINDEV, HEXDIGIT( (I&$FF)/16 ));
CHOUT(BINDEV, HEXDIGIT(REM(0)));
end;	\HEXB



proc	SYMOUT(SYM);	\Output symbol name at 'SYM'
int	SYM;
int	I, C;
begin
for I:= 0, SIGCHAR-1 do
	begin
	C:= SYMBOL(SYM);
	if C=$20 then return;
	CHOUT(BINDEV, C);
	SYM:= SYM +SYMAX;
	end;
end;	\SYMOUT

\=============================== CODE GENERATOR ================================

proc	TTXT(STR);	\Output (opcode) string to BINDEV (the .asm output file)
char	STR;
int	I, CH;
begin
for I:= 0, 32000 do
	begin
	CH:= STR(I);
	if CH >= $80 then 
		[CH:= CH & $7F;   I:= 32000];
	if CH=^| then CRLF(BINDEV) else CHOUT(BINDEV, CH);
	end
end;	\TTXT



proc	LOCOUT;		\Output current local label (LL) to BINDEV
\These labels are local to the code generator. Use CLABEL for ordinary labels.
begin
TEXT(BINDEV, "LL");
INTOUT(BINDEV, LOCAL);
end;	\LOCOUT



proc	OPTNEWLEVEL(L);	\Set IX for current level for an optimized procedure.
\Note that an optimized procedure can be called from a procedure at a deeper
\ level, thus IX must be set to make sure it is at the current level. Even
\ though an optimized procedure does not have any local variables, the variables
\ of the surrounding (next lower) level are handled as local.
\ 
int	L;	\current level
begin
if L > 0 then
	[TTXT("	PSX|	LDX	(BASE"); INTOUT(BINDEV, L/2); TTXT(")|")];
OLDLEV:= -1;		\IY is undefined at the start of a procedure
end;	\OPTNEWLEVEL



proc	NEWLEVEL(L);	\Set IY to access an intermediate level if needed.
\Intermediate levels are neither local or global. Only used when there are
\ three or more levels of static nesting.
int	L;
begin
if L#0 & L#OLDLEV & L#LEVEL then
	begin
	TTXT("	LDY	(BASE"); INTOUT(BINDEV, L/2); TTXT(")|");
	OLDLEV:= L;
	end;
end;	\NEWLEVEL

\------------ ROUTINES TO HANDLE INTERNAL OPTIMIZING (PSEUDO) STACK ------------
\
\The main body of the compiler generates intermediate-level code (sometimes
\ called I2L) that gets converted into low-level assembly code by this section.
\ Intermediate code is stack-oriented: all operations are done on a stack, for
\ example: TOS:= NOS - TOS. This means that the value in the top of the stack
\ (TOS) is replaced with the difference between it and the next item on the
\ stack (NOS). The stack initially contained two items that were replaced by a
\ single item.
\
\Intermediate code can be converted on a one-for-one basis to assembly code, but
\ it is about twice as efficient (i.e: about half as many assembly instructions
\ are required) if several I2L codes are examined before converting them. The
\ pseudo stack is a type of buffer that enables this. It mirrors the operations
\ that occur when the code is executed. It records where operands reside; either
\ in the accumulator (AC), on the hardware stack, in memory at a level and
\ offset; or it records the value of immediate operands.
\
\The accumulator (AC) normally holds the TOS value. 


proc	SHOWSTK;	\Debugging routine to show the pseudo stack
int	P;
begin
if not COMFLG then return;
TEXT(BINDEV, "; ==============================
");
for P:= 0, PSTKPTR-1 do
	begin
	TEXT(BINDEV, "; ");
	case P of
	  PSTKPTR-1:	TEXT(BINDEV, "TOS-> ");	\top of stack
	  PSTKPTR-2:	TEXT(BINDEV, "NOS-> ")	\next on stack
	other TEXT(BINDEV, "      ");

	case PSTKTYP(P) of
	  REGTYP:	TEXT(BINDEV, "REG");	\operand is in AC
	  STKTYP:	TEXT(BINDEV, "STK");	\operand is on H/W stack
	  ADRTYP:	TEXT(BINDEV, "ADR");	\operand is in a memory address
	  IMMTYP:	TEXT(BINDEV, "IMM");	\operand is an immediate value
	  REALTYP:	TEXT(BINDEV, "FLT")	\operand is a real on H/W stack
	other;

	TEXT(BINDEV, " -- ");
	INTOUT(BINDEV, PSTKLEV(P)); TEXT(BINDEV, " -- ");

	if PSTKTYP(P)=ADRTYP then
		INTOUT(BINDEV, PSTKOFF(P)>>1)	\convert byte offset to word off
	else if PSTKTYP(P)=IMMTYP then
		CHOUT(BINDEV, PSTKOFF(P))
	else	INTOUT(BINDEV, PSTKOFF(P));
	CRLF(BINDEV);
	end;
TEXT(BINDEV, "; ==============================
");
end;	\SHOWSTK



proc	BUGMSG(S);	\Display message for internal compiler error (i.e: bug)
int	S;		\(This routine never gets called. Yeah, right.   8-)
begin
TEXT(TV, "INTERNAL ERROR - "); TEXT(TV, S); CRLF(TV);
TTXT(";INTERNAL ERROR - "); TTXT(S); CRLF(BINDEV);
end;	\BUGMSG


	
proc	PPUSH(TYP, LEV, OFF);	\Push an item onto the pseudo stack
int	TYP, LEV, OFF;
begin
PSTKTYP(PSTKPTR):= TYP;		\type: REGTYP, STKTYP, ADRTYP, IMMTYP, REALTYP
PSTKLEV(PSTKPTR):= LEV;		\level of addr operand or immediate value
PSTKOFF(PSTKPTR):= OFF;		\offset of addr operand or ^C or ^L
PSTKPTR:= PSTKPTR+1;
end;	\PPUSH



proc	PDROP(N);	\Drop (pop) N items from the pseudo stack
int	N;
begin
PSTKPTR:= PSTKPTR-N;
if PSTKPTR < 0 then [PSTKPTR:= 0; BUGMSG("PDROP PSTKPTR<0")];
end;	\PDROP



proc	PSWAP;		\Swap top two items on the pseudo stack
int	T;
begin
T:= PSTKTYP(PSTKPTR-2);
PSTKTYP(PSTKPTR-2):= PSTKTYP(PSTKPTR-1);
PSTKTYP(PSTKPTR-1):= T;

T:= PSTKLEV(PSTKPTR-2);
PSTKLEV(PSTKPTR-2):= PSTKLEV(PSTKPTR-1);
PSTKLEV(PSTKPTR-1):= T;

T:= PSTKOFF(PSTKPTR-2);
PSTKOFF(PSTKPTR-2):= PSTKOFF(PSTKPTR-1);
PSTKOFF(PSTKPTR-1):= T;
end;	\PSWAP



proc	GENAC(L, O);	\Generate code to put an immediate value into AC
int	L,	\the value to generate
	O;	\^L or ^C (label or constant)
begin
CHOUT(BINDEV,^	);			\leading tab character
case of
  O = ^L:		[TTXT("LDA	L"); INTOUT(BINDEV, L)];

\0-word solution:
  L=ACVAL & ACIMM:	[];		\it's already in AC

\1-word solutions:
  L=0:			TTXT("CLR");
  L=-1:			TTXT("SET");
  L=-ACVAL & ACIMM:	TTXT("NEG");	\(beware of $8000)
  L=(~ACVAL) & ACIMM:	TTXT("COM");
  L=ACVAL<<1 & ACIMM:	TTXT("SHL");
  L=ACVAL>>1 & ACIMM:	TTXT("LSR");
  L=ACVAL+1 & ACIMM:	TTXT("INC");
  L=ACVAL-1 & ACIMM:	TTXT("DEC")

\2-word solution:
other			[TTXT("LDA	"); INTOUT(BINDEV, L)];
CRLF(BINDEV);				\terminating CR LF

ACIMM:= O # ^L;				\if the immediate value is not a label
if ACIMM then ACVAL:= L;		\ then let the compiler know what it is
ACLEV:= -1;				\AC does not contain a variable
end;	\GENAC



func	IDENTITY(N,COMM);\Eliminate identity operations such as A+0 and A*1
int	N,		\returns 'true' if it was an identity operation
	COMM;		\operation is commutative
begin
if PSTKTYP(PSTKPTR-1)=IMMTYP & PSTKLEV(PSTKPTR-1)=N & PSTKOFF(PSTKPTR-1)=^C then
	[PDROP(1); return true];

if COMM then
	begin
	if PSTKTYP(PSTKPTR-2)=IMMTYP & PSTKLEV(PSTKPTR-2)=N &
	    PSTKOFF(PSTKPTR-2)=^C then
		begin			\eliminate identity operator
		PSTKTYP(PSTKPTR-2):= PSTKTYP(PSTKPTR-1);
		PSTKLEV(PSTKPTR-2):= PSTKLEV(PSTKPTR-1);
		PSTKOFF(PSTKPTR-2):= PSTKOFF(PSTKPTR-1);
		PDROP(1);
		return true;
		end
	end;
return false;
end;	\IDENTITY



proc	OPSTRING(STR, TYP, LEV, OFF, REG);
\Output opcode string with embedded operands or registers.
\ Special string symbols: |=crlf, &=operand, #=register.
\WARNINGS: OPSTRING("  STY  &|", ^A...) is illegal. Also NEWLEVEL can alter IY.
char	STR;	\string
int	TYP,	\type of operand (&: ^A, ^I or ^S)
	LEV,	\level if address (A), value if immediate (I), or string if (S)
	OFF,	\offset for (byte) address, or ^L for labels
	REG;	\register (#: ^A, ^X or ^Y)
int	I, CH;
begin
if TYP=^A then NEWLEVEL(LEV);  \if address operand, make sure IY is set properly

for I:= 0, 32000 do
	begin
	CH:= STR(I) & $7F;
	case CH of
	  ^&:	begin				      \OPERAND
		case TYP of
		  ^A:	begin				\ADDRESS
			case LEV of
			  0:	TTXT("(HEAPLO+");
			  LEVEL:TTXT("(IX+")
			other	TTXT("(IY+");		\intermediate level
			INTOUT(BINDEV, OFF>>1);		\convert bytes to words
			CHOUT(BINDEV,^));
			end;
		  ^I:	begin				\IMMEDIATE
			if OFF=^L then
				CHOUT(BINDEV,^L);	\label (for text strings
			INTOUT(BINDEV, LEV);		\ (or constant arrays)
			end;
		  ^S:	TEXT(BINDEV, LEV)		\STRING, e.g: "(SP+0)"
		other	BUGMSG("OPSTRING");
		end;
	  ^#:	begin				      \REGISTER
		case REG of
		  ^A:	CHOUT(BINDEV,^A);
		  ^X:	CHOUT(BINDEV,^X);
		  ^Y:	CHOUT(BINDEV,^Y)
		other	BUGMSG("OPSTRING2");
		end;
	  ^|:	CRLF(BINDEV)
	other	CHOUT(BINDEV, CH);
	if STR(I) >= $80 then return;
	end
end;	\OPSTRING



proc	TOS2REG(R);	\Copy TOS into register specified by 'R' (^A, ^X or ^Y)
int	R, TOS;		\ (unless TOS is a real)
begin			\WARNING: ADRTYP can alter IY
case PSTKTYP(PSTKPTR-1) of
  REGTYP: if R#^A then OPSTRING("	MA#|", 0, 0, 0, R);
  STKTYP: begin
	  OPSTRING("	PO#|", 0, 0, 0, R);
	  if R = ^A then [ACLEV:= -1; ACIMM:= false];
	  end;
  ADRTYP: begin
	  OPSTRING("	LD#	&|", ^A, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), R);
	  if R = ^A then
		[ACLEV:= PSTKLEV(PSTKPTR-1); ACOFF:= PSTKOFF(PSTKPTR-1);
		ACIMM:= false];
	  end;
  IMMTYP: if R=^A then GENAC(PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1))
	  else	OPSTRING("	LD#	&|", ^I, PSTKLEV(PSTKPTR-1),
			PSTKOFF(PSTKPTR-1), R)\;
\ REALTYP: []
other	BUGMSG("TOS2REG");
if R = ^Y then OLDLEV:= -1;
end;	\TOS2REG



proc	ADDTOS2AC;	\Add TOS to AC then pop TOS (for indexing operations)
begin			\WARNING: ADRTYP can alter IY
case PSTKTYP(PSTKPTR-1) of
  REGTYP: TTXT("	SHL|");		\(should never occur, but it's ok)
  STKTYP: TTXT("	ADD	(SP+0)|	INS|");
  ADRTYP: OPSTRING("	ADD	&|", ^A, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
  IMMTYP: if PSTKLEV(PSTKPTR-1)#0 \& #^L\ then
		OPSTRING("	ADD	&|", ^I, PSTKLEV(PSTKPTR-1),
				PSTKOFF(PSTKPTR-1), 0)\;
\  REALTYP: []
other	BUGMSG("ADDTOS2AC");
ACLEV:= -1; ACIMM:= false;
end;	\ADDTOS2AC



proc	CLEANREG(LEV); \Push any AC below LEV in the pseudo stack onto H/W stack
int	LEV;	\i.e: clean AC off pseudo stack because AC is about to be used.
int	I;	\e.g: if LEV=2 then the top two items are left alone.
begin
for I:= 0, PSTKPTR-(LEV+1) do	\from the bottom of the stack toward the top...
	if PSTKTYP(I) = REGTYP then
		[TTXT("	PSA|");
		PSTKTYP(I):= STKTYP];
end;	\CLEANREG



proc	TOS2HARD;   \Make sure TOS is a hard value, either in AC or on H/W stack
begin		    \WARNING: ADRTYP can alter IY
if PSTKPTR < 1 then [BUGMSG("TOS2HARD"); return];
case PSTKTYP(PSTKPTR-1) of
  REGTYP, STKTYP, REALTYP: return;
  ADRTYP:
	begin
	CLEANREG(1);	\AC on TOS is ok, but stack it if it's below TOS
	OPSTRING("	LDA	&|", ^A, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
	ACLEV:= PSTKLEV(PSTKPTR-1); ACOFF:= PSTKOFF(PSTKPTR-1);
	ACIMM:= false;
	end;
  IMMTYP:
	begin
	CLEANREG(1);
	GENAC(PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1));
	end
other	BUGMSG("TOS2HARD");
PSTKTYP(PSTKPTR-1):= REGTYP;
end;	\TOS2HARD



proc	TOS2STACK;	\Make sure TOS is in the top of the hardware stack
begin			\WARNING: ADRTYP can alter IY
if PSTKPTR < 1 then [BUGMSG("TOS2STACK"); return];
case PSTKTYP(PSTKPTR-1) of
  REGTYP: TTXT("	PSA|");
  STKTYP: [];
  ADRTYP: begin
	  CLEANREG(1);
	  OPSTRING("	LDA	&|", ^A, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
	  ACLEV:= PSTKLEV(PSTKPTR-1); ACOFF:= PSTKOFF(PSTKPTR-1);
	  ACIMM:= false;
	  TTXT("	PSA|");
	  end;
  IMMTYP: begin
	  CLEANREG(1);
	  GENAC(PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1));
	  TTXT("	PSA|");
	  end;
  REALTYP: []		\it is already on the hardware stack
other	BUGMSG("TOS2STACK");
PSTKTYP(PSTKPTR-1):= STKTYP;
end;	\TOS2STACK



proc	TOS2AC;		\Make sure TOS is in AC
begin
CLEANREG(1);
TOS2REG(^A);		\WARNING: Can alter IY
PSTKTYP(PSTKPTR-1):= REGTYP;
end;	\TOS2AC



proc	GENOP2(OPSTR, REV, OP);	\Output assembly code for 2-operand expressions
char	OPSTR;	\assembly code string containing operator (such as XOR or SUB)
int	REV;	\flag: reverse-order opcode (operation is not commutative)
char	OP;	\string: contains operator for IMM_IMM case (i.e: ">=")
int	TOS, NOS;
\This routine generates code for expressions of the form: TOS:= NOS op TOS. NOS
\ and TOS are operands on the pseudo stack. On the D16 computer all such (binary)
\ operations must use the accumulator. Thus one of the operands (NOS or TOS) is
\ loaded into AC, and the other operand, specified by "&", is accessed either
\ from memory or as an immediate value. Operands in memory can be either normal
\ variables (with their level and offset), a value on the hardware stack (SP+0),
\ or a temporary value set up in TEMP.

	\Procedure name order: DO_NOS_TOS

	proc	DO_REG_REG;				\0
	begin
	if ACLEV>=0 then	\if AC mirrors an address, use the address
		OPSTRING(OPSTR, ^A, ACLEV, ACOFF, 0)
	else	begin
		TTXT("	sta	(temp)|");
		OPSTRING(OPSTR, ^S, "(temp)", 0, 0);
		end;
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_REG_REG



	proc	DO_STK_REG;				\1
	begin		\NOS is on h/w stack; TOS is in AC
	if REV then	\SUBtract must use the less efficient order: NOS - TOS
	   begin
	   if ACLEV>=0 then	\if AC mirrors an address, use the address
		begin
		TTXT("	POA|");
		OPSTRING(OPSTR, ^A, ACLEV, ACOFF, 0);
		end
	   else	begin
		TTXT("	STA	(TEMP)|	POA|");
		OPSTRING(OPSTR, ^S, "(TEMP)", 0, 0);
		end;
	   end
	else	begin
		OPSTRING(OPSTR, ^S, "(SP+0)", 0, 0);	\(SP+0) = top of h/w stk
		TTXT("	INS|");		\drop item from stack (increment SP)
		end;
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_STK_REG


	proc	DO_ADR_REG;				\2
	int	SLEV, SOFF;
	begin
	if REV then
	   begin
	   if ACLEV>=0 then	\if AC mirrors an address, use the address
		begin
		SLEV:= ACLEV; SOFF:= ACOFF;
		OPSTRING("	LDA	&|", ^A,
			PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2), 0);
		ACLEV:= PSTKLEV(PSTKPTR-2); ACOFF:= PSTKOFF(PSTKPTR-2);
		ACIMM:= false;
		OPSTRING(OPSTR, ^A, SLEV, SOFF, 0);
		end
	   else	begin
		OPSTRING("	STA	(TEMP)|	LDA	&|", ^A,
			PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2), 0);
		ACLEV:= PSTKLEV(PSTKPTR-2); ACOFF:= PSTKOFF(PSTKPTR-2);
		ACIMM:= false;
		OPSTRING(OPSTR, ^S, "(TEMP)", 0, 0);
		end;
	   end
	else	OPSTRING(OPSTR, ^A, PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2), 0);
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_ADR_REG


	proc	DO_IMM_REG;				\3
	int	SLEV, SOFF;
	begin
	if REV then
	   begin
	   if ACLEV>=0 then	\if AC mirrors an address, use the address
		begin
		SLEV:= ACLEV; SOFF:= ACOFF;
		GENAC(PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2));
		OPSTRING(OPSTR, ^A, SLEV, SOFF, 0);
		end
	   else	begin
		TTXT("	STA	(TEMP)|");
		GENAC(PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2));
		OPSTRING(OPSTR, ^S, "(TEMP)", 0, 0);
		end;
	   end
	else	OPSTRING(OPSTR, ^I, PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2), 0);
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_IMM_REG


	proc	DO_REG_STK;				\4
	begin
	OPSTRING(OPSTR, ^S, "(SP+0)", 0, 0);
	TTXT("	INS|");
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_REG_STK


	proc	DO_STK_STK;				\5
	begin
	TTXT("	POA|");
	ACLEV:= -1; ACIMM:= false;
	DO_STK_REG;
	end;	\DO_STK_STK


	proc	DO_ADR_STK;				\6
	begin
	if REV then
		begin
		OPSTRING("	LDA	&|", ^A,
			PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2), 0);
		ACLEV:= PSTKLEV(PSTKPTR-2); ACOFF:= PSTKOFF(PSTKPTR-2);
		ACIMM:= false;
		OPSTRING(OPSTR, ^S, "(SP+0)", 0, 0);
		TTXT("	INS|");
		end
	else	begin
		TTXT("	POA|");
		ACLEV:= -1; ACIMM:= false;
		OPSTRING(OPSTR, ^A, PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2), 0);
		end;
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_ADR_STK


	proc	DO_IMM_STK;				\7
	begin
	if REV then
		begin
		GENAC(PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2));
		OPSTRING(OPSTR, ^S, "(SP+0)", 0, 0);
		TTXT("	INS|");
		end
	else	begin
		TTXT("	POA|");
		ACLEV:= -1; ACIMM:= false;
		OPSTRING(OPSTR, ^I, PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2), 0);
		end;
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_IMM_STK


	proc	DO_REG_ADR;				\8
	begin
	OPSTRING(OPSTR, ^A, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_REG_ADR


	proc	DO_STK_ADR;				\9
	begin
	TTXT("	POA|");
	ACLEV:= -1; ACIMM:= false;
	OPSTRING(OPSTR, ^A, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_STK_ADR


	proc	DO_ADR_ADR;				\10
	begin
	OPSTRING("	LDA	&|", ^A, PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2), 0);
	ACLEV:= PSTKLEV(PSTKPTR-2); ACOFF:= PSTKOFF(PSTKPTR-2);
	ACIMM:= false;
	OPSTRING(OPSTR, ^A, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_ADR_ADR


	proc	DO_IMM_ADR;				\11
	begin
	GENAC(PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2));
	OPSTRING(OPSTR, ^A, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_IMM_ADR


	proc	DO_REG_IMM;				\12
	begin
	OPSTRING(OPSTR, ^I, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_REG_IMM


	proc	DO_STK_IMM;				\13
	begin
	TTXT("	POA|");
	ACLEV:= -1; ACIMM:= false;
	OPSTRING(OPSTR, ^I, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_STK_IMM


	proc	DO_ADR_IMM;				\14
	begin
	OPSTRING("	LDA	&|", ^A, PSTKLEV(PSTKPTR-2), PSTKOFF(PSTKPTR-2), 0);
	ACLEV:= PSTKLEV(PSTKPTR-2); ACOFF:= PSTKOFF(PSTKPTR-2);
	ACIMM:= false;
	OPSTRING(OPSTR, ^I, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
	PDROP(2);
	PPUSH(REGTYP, 0, 0);
	end;	\DO_ADR_IMM


	proc	DO_IMM_IMM;				\15
	\WARNING: This must not affect AC (not clean)
	int	TOSVAL, NOSVAL, C1, C2, REMAIN;
	begin
	if PSTKOFF(PSTKPTR-1)#^C ! PSTKOFF(PSTKPTR-2)#^C then
		BUGMSG("DO_IMM_IMM LABELS");

	TOSVAL:= PSTKLEV(PSTKPTR-1);
	NOSVAL:= PSTKLEV(PSTKPTR-2);
	C1:= OP(0); C2:= OP(1);		\get operator symbol from string
	C2:= if C1>=$80 then 0 else C2 & $7F;
	C1:= C1 & $7F;
	case C1 of
	  ^=:	TOSVAL:= NOSVAL=TOSVAL;
	  ^#:	TOSVAL:= NOSVAL#TOSVAL;
	  ^>:	TOSVAL:= if C2=^= then NOSVAL>=TOSVAL else NOSVAL>TOSVAL;
	  ^<:	TOSVAL:= if C2=^= then NOSVAL<=TOSVAL else NOSVAL<TOSVAL;
	  ^!:	TOSVAL:= NOSVAL!TOSVAL;
	  ^&:	TOSVAL:= NOSVAL&TOSVAL;
	  ^|:	TOSVAL:= NOSVAL|TOSVAL;
	  ^+:	TOSVAL:= NOSVAL+TOSVAL;
	  ^-:	TOSVAL:= NOSVAL-TOSVAL;
	  ^*:	TOSVAL:= NOSVAL*TOSVAL;
	  ^/:	begin
		if TOSVAL=0 then [ERROR(73); TOSVAL:= $7FFF; REMAIN:= 0]
		else [TOSVAL:= NOSVAL/TOSVAL; REMAIN:= REM(0)];
		OPSTRING("	LDY	&|", ^I, REMAIN, ^C, 0);
		TTXT("	STY	(REMAIN)|");
		OLDLEV:= -1;		\IY is bombed
		end
	other	BUGMSG("DO_IMM_IMM");
	PDROP(2);
	PPUSH(IMMTYP, TOSVAL, ^C);
	end;	\DO_IMM_IMM


begin	\GENOP2
if PSTKPTR < 2 then BUGMSG("GENOP2");		\must have at least two operands

if PSTKTYP(PSTKPTR-1)=IMMTYP & PSTKOFF(PSTKPTR-1)#^C !	\handle "name"+2, etc.
   PSTKTYP(PSTKPTR-2)=IMMTYP & PSTKOFF(PSTKPTR-2)#^C then
	[TOS2HARD; ACLEV:= -1; ACIMM:= false];

TOS:= PSTKTYP(PSTKPTR-1);
NOS:= PSTKTYP(PSTKPTR-2);
if TOS#IMMTYP ! NOS#IMMTYP then CLEANREG(2);	\if they're not both immediates
						\we are about to use AC
\Generate code for all possible combinations of binary operations on NOS and TOS
case of
  NOS=REGTYP & TOS=REGTYP: DO_REG_REG;			\0
  NOS=STKTYP & TOS=REGTYP: DO_STK_REG;			\1
  NOS=ADRTYP & TOS=REGTYP: DO_ADR_REG;			\2
  NOS=IMMTYP & TOS=REGTYP: DO_IMM_REG;			\3

  NOS=REGTYP & TOS=STKTYP: DO_REG_STK;			\4
  NOS=STKTYP & TOS=STKTYP: DO_STK_STK;			\5
  NOS=ADRTYP & TOS=STKTYP: DO_ADR_STK;			\6
  NOS=IMMTYP & TOS=STKTYP: DO_IMM_STK;			\7

  NOS=REGTYP & TOS=ADRTYP: DO_REG_ADR;			\8
  NOS=STKTYP & TOS=ADRTYP: DO_STK_ADR;			\9
  NOS=ADRTYP & TOS=ADRTYP: DO_ADR_ADR;			\10
  NOS=IMMTYP & TOS=ADRTYP: DO_IMM_ADR;			\11

  NOS=REGTYP & TOS=IMMTYP: DO_REG_IMM;			\12
  NOS=STKTYP & TOS=IMMTYP: DO_STK_IMM;			\13
  NOS=ADRTYP & TOS=IMMTYP: DO_ADR_IMM;			\14
  NOS=IMMTYP & TOS=IMMTYP: DO_IMM_IMM			\15
other	BUGMSG("GENOP2A");
end;	\GENOP2

\------------------------ ROUTINES TO GENERATE OPCODES -------------------------

proc	GENSTART;	\Generate the beginning of a compiled program
begin
TTXT("	INCL	^"D16RUN.ASM^"||");	\include runtime support code
TTXT("PROGRM|");			\label at start of compiled code
end;	\GENSTART



proc	DSTART;		\Start data section (for strings and constant arrays)
TTXT("|CODE	SETL	$|	ORG	DATA|");



proc	DEND;		\End data section and resume code section
TTXT("|DATA	SETL	$|	ORG	CODE|");



proc	STARTSEG(LEV,SEG);	\Start a new code segment (unused by D16)
int	LEV,SEG;
begin
end;	\STARTSEG



proc	DLABEL(N);	\Make a data label
int	N;
begin
TTXT("|L");	\"|" is necessary because there might already be a label here
INTOUT(BINDEV,N);
end;	\DLABEL



proc	FLABEL(N);	\Make a label for a forward procedure. (Same as CLABEL.)
int	N;
begin
DLABEL(N);
if DEBUG then CRLF(BINDEV);
LASTOP:= -1;		\we might not be coming from the previous opcode
OLDLEV:= -1;		\ so we don't know what's in IY or AC
ACLEV:= -1;
ACIMM:= false;
end;	\FLABEL



proc	CLABEL(N);	\Make a code label. (This is the most common label.)
int	N;
begin
DLABEL(N);
if DEBUG then CRLF(BINDEV);
LASTOP:= -1;		\we might not be coming from the previous opcode
OLDLEV:= -1;
ACLEV:= -1;
ACIMM:= false;
end;	\CLABEL



func	NEWLAB;		\Generate a new label number
begin
LABCNT:= LABCNT+1;
return LABCNT;
end;	\NEWLAB



proc	COMMENT(OPC);	\All opcode generating routines must call this procedure
int	OPC;
int	COMTB1, COMTB2, C;
begin
LASTOP:= OPC;		\record opcode so some peephole optimiaztion can be done
CODCTR:= CODCTR +1;	\count number of code segments that are generated
if not COMFLG then return;	\"/C" command-line switch (used for debugging)

COMTB1:=
 ["EXIT","LOD","LDX","STO","STX","CAL","RET","JMP","JPC","HPI","ARG","IMM",
 "CML","ADD","SUB","MUL","DIV","NEG","EQ","NE","GE","GT","LE","LT","FOR",
 "INP","OR","AND","NOT","EOR","DBA","STD","DBX","ADR","LDI","LDA","IMS",
 "CJP","JSR","RTS","DRP","CEXT","FLOD","FSTO","FIMM","FADD","FSUB","FMUL",
 "FDIV","FNEG","FEQ","FNE","FGE","FGT","FLE","FLT","TRA","TRX","TRI","STT",
 "MARK","?","LSL","LSR","LDSI","LDSB","LDSR","STSI","STSB","STSR","LSHORT",
 "SSHORT","MKARRAY","ABS","FABS","REM","SWAP","EXT","PIN","POUT" ];

COMTB2:= ["TXT","FLT","INT","END","NUL"];

SHOWSTK;
CRLF(BINDEV);
TEXT(BINDEV, "; $"); HEXB(OPC); TEXT(BINDEV, " - ");
TEXT(BINDEV, if OPC >= $FB then COMTB2(OPC-$FB) else COMTB1(OPC));
CRLF(BINDEV);
end;	\COMMENT



proc	GENEXIT;	\$00: Generate code to exit the XPL program
begin
COMMENT($00);	\restore saved stack pointer so we can exit from anywhere
TTXT("	LDS	(STKPTR)|	RTN|");
end;	\GENEXIT



proc	GENLOD(L, O);	\$01: TOS:= @(Level + Offset)
int	L, O;	\level and offset of variable to load onto stack
begin		\This merely loads the pseudo stack. The code is generated later
COMMENT($01);
if L=ACLEV & O=ACOFF then	\TOS is in AC
	PPUSH(REGTYP, 0, 0)	\push TOS onto pseudo stack, as either the value
else	PPUSH(ADRTYP, L, O);	\ in AC or as the value at a memory address
end;	\GENLOD



proc	GENLDX;		\$02: TOS:= @(NOS + TOS)
int	C;		\NOS=base addr; TOS=index (one byte per word)
begin			\used to load an item from a character array
COMMENT($02);
CLEANREG(2);		\make sure AC is not used below the top 2 items on p-stk
if PSTKTYP(PSTKPTR-1)=IMMTYP then
	begin		\TOS is an immediate value
	C:= PSTKLEV(PSTKPTR-1);
	PDROP(1);
	TOS2REG(^Y);	\IY:= what was NOS
	TTXT("	LDA	(IY+"); INTOUT(BINDEV,C); TTXT(")|");
	end
else	begin
	CLEANREG(1);	\make sure NOS is not in AC
	TOS2REG(^A);
	PDROP(1);
	ADDTOS2AC;
	TTXT("	MAY|	LDA	(IY+0)|");
	OLDLEV:= -1;
	end;
PDROP(1);

TTXT("	AND	00FFh|");
\GENSTX, SHIFT and GENPOUT elimiate this AND instruction

PPUSH(REGTYP, 0, 0);
ACLEV:= -1; ACIMM:= false; OLDLEV:= -1;
end;	\GENLDX



proc	GENSTO(L, O);	\$03: @(Level + Offset):= TOS
int	L, O;		\level and offset of variable to store into
begin			\the top item on the stack is popped off and stored
COMMENT($03);
case PSTKTYP(PSTKPTR-1) of
  REGTYP: [OPSTRING("	STA	&|",	^A, L, O, 0);
	   ACLEV:= L; ACOFF:= O];
  STKTYP: [OPSTRING("	POA|	STA	&|",	^A, L, O, 0);
	   ACLEV:= L; ACOFF:= O; ACIMM:= false];
  ADRTYP: if L#PSTKLEV(PSTKPTR-1) ! O#PSTKOFF(PSTKPTR-1) then	\don't do I:= I
	    [OPSTRING("	LDA	&|",	^A, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
	     OPSTRING("	STA	&|",	^A, L, O, 0);
	     ACLEV:= L; ACOFF:= O; ACIMM:= false];
  IMMTYP: begin
	  GENAC(PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1));
	  OPSTRING("	STA	&|",	^A, L, O, 0);
	  ACLEV:= L; ACOFF:= O;
	  end
other	  BUGMSG("GENSTO");
PDROP(1);
end;	\GENSTO



proc	GENSTX;		\$04: @(NOS):= TOS (one byte per word)
\It's not necessary to mask off the high 8 bits here because LDX does it
\XPL code can detect the difference between D16 and PC, for example:
\	int I;
\	char A;
\	begin
\	I:= $1234;
\	A:= addr I;
\	if A(1) # $12 then D16 else PC

int	LEV, OFF, TOS, NOS, LOP;
begin
LOP:= LASTOP;
COMMENT($04);
if LOP=\LDX\$02 ! LOP=\PIN\$4E then
	TTXT("	ORG	$-2|");		\backup over the "AND 00FFh"
TOS:= PSTKTYP(PSTKPTR-1);
NOS:= PSTKTYP(PSTKPTR-2);
LEV:= PSTKLEV(PSTKPTR-1);
OFF:= PSTKOFF(PSTKPTR-1);

if TOS=IMMTYP then
	begin
	PDROP(1);
	TOS2REG(^Y);
	GENAC(LEV, OFF);
	TTXT("	STA	(IY+0)|");
	PDROP(1);
	end
else	begin
	if NOS=REGTYP then
		begin
		if TOS=ADRTYP & LEV#LEVEL & LEV#0 then
			begin		\TOS = intermediate variable
			TTXT("	PSA|");
			TOS2REG(^A);	\this alters IY
			TTXT("	POY|");
			OLDLEV:= -1;
			end
		else	begin
			TTXT("	MAY|");
			OLDLEV:= -1;
			TOS2REG(^A);	\this does not alter IY (unless TOS is
			PDROP(2);	\ an intermediate variable)
			end;
		end
	else	begin
		TOS2REG(^A); PDROP(1);
		TOS2REG(^Y); PDROP(1);
		end;
	TTXT("	STA	(IY+0)|");
	end;
ACLEV:= -1; ACIMM:= false;
end;	\GENSTX



proc	GENCAL(LABEL, EXT);	\$05: Procedure (or function) call
int	LABEL,
	EXT;	\flag: external
begin
COMMENT($05);
TTXT("	CSR	");
if EXT then [CHOUT(BINDEV, ^_); SYMOUT(LABEL)]
else [TTXT("L"); INTOUT(BINDEV, LABEL)];
CRLF(BINDEV);
OLDLEV:= -1;		\subroutine might have destroyed registers
ACLEV:= -1;
ACIMM:= false;
end;	\GENCAL



proc	DOJUMP(L);
int	L;
begin
TTXT("	JMP	L"); INTOUT(BINDEV, L);
CRLF(BINDEV);
end;	\DOJUMP



proc	GENRET(L);	\$06: Return from procedure (or function)
int	L;
int	P;
begin
if LASTOP=$00\EXIT\ ! LASTOP=$06\RET\ ! LASTOP=$07\JMP\ then return;
COMMENT($06);
if L = 0 then TTXT("	RTN|")
else	begin	\(don't alter AC because a function returns a value in it)
	L:= L >> 1;
	if PROCRETS(L)\#0\ & HAVENEST then
		DOJUMP(PROCRETS(L))	\jump to existing procedure return code
	else	begin
		if HAVENEST then
			begin		\make label for this procedure's return
			P:= NEWLAB;
			PROCRETS(L):= P;
			CLABEL(P);		\restore BASEn and HP
			TTXT("	POX|");		\get value originally in BASEn
			TTXT("	LDY	(BASE"); INTOUT(BINDEV, L); TTXT(")|");
			TTXT("	STX	(BASE"); INTOUT(BINDEV, L); TTXT(")|");
			TTXT("	STY	(HP)|	POX|	RTN|");	\restore IX
			OLDLEV:= -1;
			end
		else	TTXT("	JMP	RETDO|");
		end;
	end;
end;	\GENRET



proc	GENJSR(L);	\$26: Optimized procedure call (no local variables)
int	L;
begin
COMMENT($26);
TTXT("	CSR	L"); INTOUT(BINDEV, L); CRLF(BINDEV);
OLDLEV:= -1;		\subroutine might have destroyed registers
ACLEV:= -1;
ACIMM:= false;
end;	\GENJSR



proc	GENRTS(L);	\$27: Optimized return
int	L;
begin
if LASTOP=$00\EXIT\ ! LASTOP=$07\JMP\ ! LASTOP=$27\RTS\ then return;
COMMENT($27);
\Don't alter AC because a value might be returned in it
if L > 0 then TTXT("	POX|");
TTXT("	RTN|");
end;	\GENRTS



proc	GENCML(LABEL, LAST, TYPE, FUNC, ARGS);	\$0C: Intrinsic call
int	LABEL, LAST, TYPE, FUNC, ARGS;
begin
COMMENT($0C);
if ARGS > 0 then
	begin			\handle all combinations of arguments
	if TYPE=ININT then
		[if LAST=INTEGER then TOS2AC else TTXT("	POA|")]
	else	TOS2STACK;
	end;

TTXT("	CSR	INTR"); INTOUT(BINDEV, LABEL); CRLF(BINDEV);
PDROP(ARGS);
OLDLEV:= -1;		\intrinsic call might have destroyed registers
ACLEV:= -1;
ACIMM:= false;
if FUNC then
	case TYPE of
	  ININT: PPUSH(REGTYP, 0, 0);
	  RLINT: PPUSH(REALTYP, 0, 0)
	other 	 [];
end;	\GENCML



proc	GENCEXT(LABEL, LAST, TYPE, FUNC, ARGS);	\$29: External assembly call
int	LABEL, LAST, TYPE, FUNC, ARGS;
begin
COMMENT($29);
if ARGS>0 & LAST=INTEGER then TOS2STACK;
TTXT("	CSR	"); SYMOUT(LABEL); TTXT("|");
\WARNING: IX register must not be altered by called subroutine
PDROP(ARGS);
OLDLEV:= -1;		\subroutine call might have destroyed registers AC & IY
ACLEV:= -1;
ACIMM:= false;
if FUNC then
	case TYPE of
	  INEXT: PPUSH(STKTYP, 0, 0);
	  RLEXT: PPUSH(REALTYP, 0, 0)
	other;
end;	\GENCEXT



proc	GENJMP(L);	\$07: Jump
int	L;
begin
if LASTOP=$00\EXIT\ ! LASTOP=$06\RET\ ! LASTOP=$07\JMP\ !
	LASTOP=$27\RTS\ then return;
COMMENT($07);
DOJUMP(L);
end;	\GENJMP



proc	GENFJMP(L);	\Generate jump for 'fproc's
int	L;
begin
COMMENT($07);
TTXT("	JMP	");
CHOUT(BINDEV,^L); INTOUT(BINDEV, L); CRLF(BINDEV);
end;	\GENFJMP



proc	GENJPC(L, SENSE);	\$08: Jump if TOS='false' (or 'true')
int	L,	\label to jump to
	SENSE;	\normally = 'false', for jump on false
int	LOP, TBL;


	proc	GENJ(N);	\Generate Jcc instruction
	int	N;
	int	TBL0, TBL1;
	begin
	TBL0:= ["NZ", "OZ", "MI", "PL"];	\SENSE = false
	TBL1:= ["OZ", "NZ", "PL", "MI"];	\SENSE = true
	TTXT("	J");
	TTXT(if SENSE then TBL1(N) else TBL0(N));
	end;	\GENJ


begin	\GENJPC
LOP:= LASTOP;
COMMENT($08);
\If immediate = SENSE (usually false) then unconditionaly jump
\If immediate = SENSE (usually true) then gen no instruction
if PSTKTYP(PSTKPTR-1)=IMMTYP then
	[if (PSTKLEV(PSTKPTR-1)#0) = SENSE then [CRLF(BINDEV); DOJUMP(L)]]
else
	begin
	if LOP>=$12 & LOP<=$17 then		\optimize out comparison (ICMP)
		begin
		TTXT("	ORG	$-6|");		\back over Jcc, CLR, JMP SET
		TBL:= [0, 1, 2, 3, 2, 3];
		GENJ(TBL(LOP-$12));
		TTXT("	L"); INTOUT(BINDEV, L); CRLF(BINDEV);
		if LOP=$12\=\ & ~SENSE  !  LOP=$13\#\ & SENSE then 
			[ACIMM:= true; ACVAL:= 0];
		end
	else	begin				\normal JPC
		CLEANREG(1);
		TOS2REG(^A);
		if SENSE then
			begin
			TTXT("	JNZ");
			ACIMM:= true; ACVAL:= 0;
			end
		else	TTXT("	JOZ");
		TTXT("	L"); INTOUT(BINDEV, L); CRLF(BINDEV);
		end;
	end;
PDROP(1);
end;	\GENJPC



proc	GENHPI(V);	\$09: Increment heap pointer (HP)
int	V;	\number of bytes to add to HP
begin
COMMENT($09);
if V # 0 then	\(V might be larger than 32767 because of array declarations)
	begin
	TTXT("	LDA	(HP)|	ADD	"); INTOUT(BINDEV, V>>1);
	TTXT("|	STA	(HP)|");
	ACLEV:= -1;   ACIMM:= false;
	end;
end;	\GENHPI



proc	GENBASE(L,V);	\$09-1/2: Generate start for a procedure (or function)
int	L, V;
begin
COMMENT($09);
OLDLEV:= L;
\This isn't necessary at level 0 because RET does an EXIT and BASE0 is not used.
if L = 0 then [GENHPI(V); return];

\Simple case:
\	PSX			;preserve IX across procedure call
\	LDX	(HP)		;set IX to base of procedure's local variables
\	PSX
\	MXA			;move HP past local variables
\	ADD	SIZE		;number of words of local variables
\	STA	(HP)

\HAVENEST case:			;another procedure is nested inside current proc
\	PSX			;preserve IX across procedure call
\	LDX	(HP)		;set IX to base of procedure's local variables
\	LDA	(BASEn)		;preserve BASEn across procedure call
\	PSA
\	STX	(BASEn)		;set BASEn to base of procedure's local variables
\	MXA			;move HP past local variables
\	ADD	SIZE		;number of words of local variables
\	STA	(HP)

ACLEV:= -1; ACIMM:= false;
TTXT("	PSX|	LDX	(HP)|");
if HAVENEST then
	begin
	TTXT("	LDA	(BASE"); INTOUT(BINDEV, L/2); TTXT(")|");
	TTXT("	PSA|");
	TTXT("	STX	(BASE"); INTOUT(BINDEV, L/2); TTXT(")|");
	end
else	TTXT("	PSX|");
if V>>1 = 1 then
	TTXT("	ISZ	(HP)|")	\(never skips)
else	[TTXT("	MXA|	ADD	"); INTOUT(BINDEV,V>>1);
	TTXT("|	STA	(HP)|")];
end;	\GENBASE



\Old version - needed because of reals
proc	GENARG0(BYTES);	\$0A: Move procedure arguments from pseudo stack to heap
int	BYTES;
int	P, I, L;

	proc	HEAPOP(S, A);	\Produce heap argument operand
	int	S, A;
	begin
	TTXT(S); TTXT("WP [DI]+"); INTOUT(BINDEV, A);
	end;	\HEAPOP


	func	LOADREAL(P);	\Load a real argument into heap
	int	P;
	begin
	for P:= P, P+3 do
		begin
		HEAPOP("	POP	", BYTES-(2*P));
		CRLF(BINDEV);
		end;
	return P-1;
	end;	\LOADREAL

begin	\GENARG0
COMMENT($0A);

\If all the arguments are reals then...
P:= 1;
for I:= 1, BYTES/2 do	\for all the words on the real stack...
	begin
	if PSTKTYP(PSTKPTR-P) = REALTYP then I:= I + 3	\skip rest of real
	else I:= 30000;					\not a real--abort
	P:= P + 1;
	end;
if I < 30000 then	\all args are real
	begin
	TTXT("	MOV	BX,"); INTOUT(BINDEV,BYTES);
	\CRLF(BINDEV);
	L:= NEWLAB;
	CLABEL(L);
	TTXT("	DEC	BX
	DEC	BX
	POP	[BX+DI]
	JNE	L"); INTOUT(BINDEV, L);
	CRLF(BINDEV);

	PDROP(BYTES/RLSIZE);
	end
else
    begin		\args are mixed real and integer
    for P:= 1, BYTES/2 do
	begin
	case PSTKTYP(PSTKPTR-1) of
	REGTYP: [HEAPOP("	MOV	", BYTES-(2*P)); TTXT(",AX|"); ];
	IMMTYP: begin
		HEAPOP("	MOV	", BYTES-(2*P));
		OPSTRING(",&|", ^I, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
		end;
	ADRTYP: begin
		OPSTRING("	MOV	CX,&|",
				^A, PSTKLEV(PSTKPTR-1), PSTKOFF(PSTKPTR-1), 0);
		HEAPOP("	MOV	", BYTES-(2*P)); TTXT(",CX|");
		end;
	STKTYP: [HEAPOP("	POP	", BYTES-(2*P)); CRLF(BINDEV)];
	REALTYP: P:= LOADREAL(P)
	other BUGMSG("GENARG");
	PDROP(1);
	end;
    end;
end;	\GENARG0


\New version (doesn't work for reals)
proc	GENARG1(BYTES);	\$0A: Move procedure arguments from pseudo stack to heap
int	BYTES;
int	P, Q,	\16-bit words of arguments
	DUP;	\flag: have duplicate args

	proc	HEAPOP(I);	\Generate heap argument operand
	int	I;
	begin
	if BYTES/2-I \#0\ then
	    begin
	    if OLDLEV # -2 then	\IY does not contain HP
		begin		\Note that intermediate variables can change IY
		TTXT("	LDY	(HP)|");
		OLDLEV:= -2;	\unique code for IY=HP is also an invalid level
		end;
	    TTXT("	STA	(IY+");  INTOUT(BINDEV, BYTES/2-I);  TTXT(")|");
	    end
	else
	    TTXT("	STA	[HP]|");
	PSTKTYP(PSTKPTR-I):= -1;			\mark it off
	end;	\HEAPOP


begin	\GENARG1
COMMENT($0A);
for P:= 1, BYTES/2 do
	if PSTKTYP(PSTKPTR-P) = REGTYP then HEAPOP(P);
for P:= 1, BYTES/2 do
	if PSTKTYP(PSTKPTR-P) = STKTYP then
		begin
		TTXT("	POA|");
		ACLEV:= -1; ACIMM:= false;
		HEAPOP(P);
		end;
for P:= 1, BYTES/2 do
	begin
	if PSTKTYP(PSTKPTR-P) = IMMTYP then
	    begin
	    DUP:= false;
	    for Q:= P+1, BYTES/2 do		\scan for duplicates
		begin
		if PSTKTYP(PSTKPTR-Q) = IMMTYP then
		   if PSTKLEV(PSTKPTR-Q) = PSTKLEV(PSTKPTR-P) &
		      PSTKOFF(PSTKPTR-Q) = PSTKOFF(PSTKPTR-P) then
			begin			\duplicate found
			if ~DUP then		\if first instance
			    [DUP:= true;
			    GENAC(PSTKLEV(PSTKPTR-P), PSTKOFF(PSTKPTR-P));
			    HEAPOP(P)];
			HEAPOP(Q);
			end;
		end;
	    if ~DUP then
		[GENAC(PSTKLEV(PSTKPTR-P), PSTKOFF(PSTKPTR-P));
		HEAPOP(P)];
	    end;
	end;
for P:= 1, BYTES/2 do
	begin
	if PSTKTYP(PSTKPTR-P) = ADRTYP then
	    begin
	    DUP:= false;
	    for Q:= P+1, BYTES/2 do		\scan for duplicates
		begin
		if PSTKTYP(PSTKPTR-Q) = ADRTYP &
		   PSTKLEV(PSTKPTR-Q) = PSTKLEV(PSTKPTR-P) &
		   PSTKOFF(PSTKPTR-Q) = PSTKOFF(PSTKPTR-P) then
			begin			\duplicate found
			if ~DUP then
			    [DUP:= true;
			    OPSTRING("	LDA	&|", ^A, PSTKLEV(PSTKPTR-P),
				PSTKOFF(PSTKPTR-P), 0);
			    ACLEV:= PSTKLEV(PSTKPTR-P); ACOFF:= PSTKOFF(PSTKPTR-P);
			    ACIMM:= false;
			    HEAPOP(P)];
			HEAPOP(Q);
			end;
		end;
	    if ~DUP then
		[OPSTRING("	LDA	&|", ^A, PSTKLEV(PSTKPTR-P),
			PSTKOFF(PSTKPTR-P), 0);
		ACLEV:= PSTKLEV(PSTKPTR-P); ACOFF:= PSTKOFF(PSTKPTR-P);
		ACIMM:= false;
		HEAPOP(P)];
	    end;
	end;
for P:= 1, BYTES/2 do PDROP(1);
end;	\GENARG1



proc	GENARG(BYTES);	\$0A: Move procedure arguments from pseudo stack to heap
int	BYTES;
int	P;
begin
\If there is a real argument then handle the old way, else there is a
\ one-to-one correspondance between arguments and words passed.
for P:= 1, BYTES/2 do
	if PSTKTYP(PSTKPTR-P)=REALTYP then P:= 30000;
if P>=30000 then GENARG0(BYTES)
else GENARG1(BYTES);
end;	\GENARG



proc	GENIMM(F, V);	\$0B & $24: Generate immediate (constant) value
int	F,	\FLAG: ^L=LABEL, ^C=CONSTANT
	V;	\VALUE
begin
COMMENT($0B);
\if F = ^L then ACIMM:= false;	\\DON'T USE VALUE IN AC AS A LABEL
PPUSH(IMMTYP, V, F);
\if F = ^L then TOS2HARD;	\\(HANDLE A:= "STR"+2; ETC.)
end;	\GENIMM



proc	GENADD;		\$0D: TOS:= NOS + TOS
int	TOSTYP, NOSTYP;
begin
COMMENT($0D);
if ~IDENTITY(0,true) then
	begin
	TOSTYP:= PSTKTYP(PSTKPTR-1);
	NOSTYP:= PSTKTYP(PSTKPTR-2);
	if TOSTYP=IMMTYP & PSTKLEV(PSTKPTR-1)=1 & PSTKOFF(PSTKPTR-1)=^C &
	    NOSTYP#IMMTYP then
		begin			\optimize A+1
		PDROP(1);
		CLEANREG(1);
		TOS2REG(^A);
		TTXT("	INC|");
		ACLEV:= -1; ACVAL:= ACVAL+1;
		PSTKTYP(PSTKPTR-1):= REGTYP;
		end
	else if NOSTYP=IMMTYP & PSTKLEV(PSTKPTR-2)=1 & PSTKOFF(PSTKPTR-2)=^C &
	    TOSTYP#IMMTYP then
		begin			\optimize 1+A
		PSTKTYP(PSTKPTR-2):= PSTKTYP(PSTKPTR-1);
		PSTKLEV(PSTKPTR-2):= PSTKLEV(PSTKPTR-1);
		PSTKOFF(PSTKPTR-2):= PSTKOFF(PSTKPTR-1);
		PDROP(1);
		CLEANREG(1);
		TOS2REG(^A);
		TTXT("	INC|");
		ACLEV:= -1; ACVAL:= ACVAL+1;
		PSTKTYP(PSTKPTR-1):= REGTYP;
		end
	else	begin
		GENOP2("	ADD	&|", false, "+");
		if TOSTYP#IMMTYP ! NOSTYP#IMMTYP then
			[ACLEV:= -1; ACIMM:= false];
		end;
	end;
end;	\GENADD



proc	GENSUB;		\$0E: TOS:= NOS - TOS
int	TOSTYP, NOSTYP;
begin
COMMENT($0E);
if ~IDENTITY(0,false) then
	begin
	TOSTYP:= PSTKTYP(PSTKPTR-1);
	NOSTYP:= PSTKTYP(PSTKPTR-2);
	if TOSTYP=IMMTYP & PSTKLEV(PSTKPTR-1)=1 & PSTKOFF(PSTKPTR-1)=^C &
	    NOSTYP#IMMTYP then
		begin			\optimize A-1
		PDROP(1);
		CLEANREG(1);
		TOS2REG(^A);
		TTXT("	DEC|");
		ACLEV:= -1; ACVAL:= ACVAL-1;
		PSTKTYP(PSTKPTR-1):= REGTYP;
		end
	else	begin
		GENOP2("	SUB	&|", true, "-");
		if TOSTYP#IMMTYP ! NOSTYP#IMMTYP then
			[ACLEV:= -1; ACIMM:= false];
		end;
	end;
end;	\GENSUB



proc	GENMUL;		\$0F: TOS:= NOS * TOS
int	TOSTYP, NOSTYP;
begin
COMMENT($0F);
if ~IDENTITY(1,true) then
	begin
	TOSTYP:= PSTKTYP(PSTKPTR-1);
	NOSTYP:= PSTKTYP(PSTKPTR-2);
	if TOSTYP=IMMTYP & PSTKLEV(PSTKPTR-1)=2 & PSTKOFF(PSTKPTR-1)=^C &
	    NOSTYP#IMMTYP then
		begin			\optimize A*2
		PDROP(1);
		CLEANREG(1);
		TOS2REG(^A);
		TTXT("	SHL|");
		ACLEV:= -1; ACVAL:= ACVAL<<1;
		PSTKTYP(PSTKPTR-1):= REGTYP;
		end
	else if NOSTYP=IMMTYP & PSTKLEV(PSTKPTR-2)=2 & PSTKOFF(PSTKPTR-2)=^C &
	    TOSTYP#IMMTYP then
		begin			\optimize 2*A
		PSTKTYP(PSTKPTR-2):= PSTKTYP(PSTKPTR-1);
		PSTKLEV(PSTKPTR-2):= PSTKLEV(PSTKPTR-1);
		PSTKOFF(PSTKPTR-2):= PSTKOFF(PSTKPTR-1);
		PDROP(1);
		CLEANREG(1);
		TOS2REG(^A);
		TTXT("	SHL|");
		ACLEV:= -1; ACVAL:= ACVAL<<1;
		PSTKTYP(PSTKPTR-1):= REGTYP;
		end
	else	begin
		GENOP2("	LDY	&|	CSR	MULDO|", false, "*");
		OLDLEV:= -1;
		if TOSTYP#IMMTYP ! NOSTYP#IMMTYP then
			[ACLEV:= -1; ACIMM:= false];
		end;
	end;
end;	\GENMUL



proc	GENDIV;		\$10: TOS:= NOS / TOS; REMAIN:= remainder
int	TOSTYP, NOSTYP;
begin
COMMENT($10);
if ~IDENTITY(1,false) then
	begin
	GENOP2("	LDY	&|	CSR	DIVDO|", true, "/");
	OLDLEV:= -1;
	if TOSTYP#IMMTYP ! NOSTYP#IMMTYP then
		[ACLEV:= -1; ACIMM:= false];
	end
else	begin
	TTXT("	CLR|	STA	(REMAIN)|");
	ACLEV:= -1; ACIMM:= true; ACVAL:= 0;
	end;
end;	\GENDIV



proc	GENNEG;		\$11: TOS:= -TOS
begin
COMMENT($11);
if PSTKTYP(PSTKPTR-1)=IMMTYP then
	PSTKLEV(PSTKPTR-1):= -PSTKLEV(PSTKPTR-1)
else	begin
	CLEANREG(1);
	TOS2REG(^A);
	TTXT("	NEG|");
	ACLEV:= -1; ACVAL:= -ACVAL;
	PSTKTYP(PSTKPTR-1):= REGTYP;
	end;
end;	\GENNEG



proc	FCMP(T);	\$32-$37: Floating point comparisons
int	T;
int	CMPT;
begin
ERROR(0);
CMPT:= ["FEQDO|", "FNEDO|", "FGEDO|", "FGTDO|", "FLEDO|", "FLTDO|"];
TTXT("	CSR	");
TTXT(CMPT(T-$32));
OLDLEV:= -1;		\subroutine might have destroyed registers
ACLEV:= -1;
ACIMM:= false;
PDROP(2);
PPUSH(STKTYP, 0, 0);
end;	\FCMP



proc	ICMP(OPCODE);	\$12-$17: Integer compares:  TOS:= NOS > TOS
int	OPCODE;
int	TOS, NOS, CMPSTR;
begin
CMPSTR:= [
	"	JOZ	$+5|",	\$12	NOS = TOS
	"	JNZ	$+5|",	\$13	NOS # TOS
	"	JPL	$+5|",	\$14	NOS >=TOS
	"	JMI	$+5|",	\$15	NOS > TOS; TOS <  NOS
	"	JPL	$+5|",	\$16	NOS <=TOS; TOS >= NOS
	"	JMI	$+5|"];	\$17	NOS < TOS

if PSTKPTR<2 then BUGMSG("ICMP");
TOS:= PSTKTYP(PSTKPTR-1);
NOS:= PSTKTYP(PSTKPTR-2);

if TOS=IMMTYP & PSTKLEV(PSTKPTR-1)=0 & NOS#IMMTYP then
	begin				\optimize AC comparison to 0
	PDROP(1);
	TOS2AC;				\sets REGTYP
	if OPCODE=$15 ! OPCODE=$16 then TTXT("	NEG|");
	TTXT(CMPSTR(OPCODE-$12));	\GENJPC depends on these 6 words
	TTXT("	CLR|	JMP	$+3|	SET|");
	ACLEV:= -1; ACIMM:= false;	\result is REGTYP
	end
else if TOS=IMMTYP & NOS=IMMTYP then
	begin				\TOS and NOS are both immediates
	CMPSTR:= ["=", "#", ">=", ">", "<=", "<"];
	GENOP2("	SUB	&|", true, CMPSTR(OPCODE-$12));
	\ACLEV etc. are set by GENOP2 for this IMM_IMM case
	LASTOP:= -1;			\don't optimize next JPC
	end				\result is IMMTYP
else	begin
	if OPCODE=$15 ! OPCODE=$16 then PSWAP;
	GENOP2("	SUB	&|", OPCODE>=$14 & OPCODE<=$17, "-"); \sets REGTYP
	ACLEV:= -1; ACIMM:= false;
	TOS2AC;				\make sure TOS is in REG (sets REGTYP)
	TTXT(CMPSTR(OPCODE-$12));	\GENJPC depends on these 6 words
	TTXT("	CLR|	JMP	$+3|	SET|");
	ACLEV:= -1; ACIMM:= false;	\result is REGTYP
	end;
end;	\ICMP



proc	GENCMP(T);	\Select integer or real compares
int	T;
begin
COMMENT(T);
if T>$17 then FCMP(T) else ICMP(T);
end;	\GENCMP



proc	GENFOR(LEV, OFF, LAB, TYP, LIMIT);	\$18: Comparison for 'for' loop
int	LEV, OFF, LAB, TYP, LIMIT;
begin
COMMENT($18);
\Assumes that AC = loop variable
if TYP=IMMTYP then
	begin
	if LIMIT # 0 then
		[TTXT("	SUB	"); INTOUT(BINDEV, LIMIT); CRLF(BINDEV)];
	end
else	TTXT("	SUB	(SP+0)|");
ACLEV:= -1; ACIMM:= false;

TTXT("	JMI	L"); INTOUT(BINDEV, LAB); CRLF(BINDEV);

if TYP#IMMTYP then TTXT("	INS|");		\discard TOS
PDROP(1);
CRLF(BINDEV);
end;	\GENFOR



proc	GENINP(L, O);	\$19: Increment 'for' loop control variable
int	L, O;
begin
COMMENT($19);
\The GENFOR code assumes that AC = loop variable
OPSTRING("	LDA	&|", ^A, L, O, 0);
TTXT("	INC|");
OPSTRING("	STA	&|", ^A, L, O, 0);
ACLEV:= L; ACOFF:= O; ACIMM:= false;
end;	\GENINP



proc	GENOR;		\$1A: TOS:= NOS ! TOS
begin
COMMENT($1A);
if ~IDENTITY(0,true) then
	begin
	GENOP2("	ORA	&|", false, "!");
	ACLEV:= -1; ACIMM:= false;
	end;
end;	\GENOR



proc	GENAND;		\$1B: TOS:= NOS & TOS
begin
COMMENT($1B);
if ~IDENTITY($FFFF,true) then
	begin
	GENOP2("	AND	&|", false, "&");
	ACLEV:= -1; ACIMM:= false;
	end;
end;	\GENAND



proc	GENNOT;		\$1C: TOS:= ~TOS
begin
COMMENT($1C);
if PSTKTYP(PSTKPTR-1)=IMMTYP then
	PSTKLEV(PSTKPTR-1):= ~ PSTKLEV(PSTKPTR-1)
else	begin
	CLEANREG(1);
	TOS2REG(^A);
	TTXT("	COM|");
	ACLEV:= -1; ACVAL:= ~ACVAL;
	PSTKTYP(PSTKPTR-1):= REGTYP;
	end;
end;	\GENNOT



proc	GENEOR;		\$1D: TOS:= NOS | TOS
begin
COMMENT($1D);
if ~IDENTITY(0,true) then
	begin
	GENOP2("	XOR	&|", false, "|");
	ACLEV:= -1; ACIMM:= false;
	end;
end;	\GENEOR



proc	DOINDEX2(PWR);	\Generate index for DBA and TRA. TOS:= NOS + TOS*2^PWR
int	PWR;	\power of two
int	TOS, NOS, C;
begin
CLEANREG(2);
TOS:= PSTKTYP(PSTKPTR-1);
NOS:= PSTKTYP(PSTKPTR-2);
if TOS=IMMTYP then
	begin
	if ~IDENTITY(0,false) then
		begin
		PSTKLEV(PSTKPTR-1):= PSTKLEV(PSTKPTR-1) << PWR;
		GENADD;
		end;
	end
else	begin
	TOS2AC;
	for C:= 1, PWR do
		[TTXT("	SHL|");
		ACLEV:= -1; ACIMM:= false];
	GENADD;
	end;
end;	\DOINDEX2



proc	GENDBA;		\$1E: TOS:= TOS + NOS
int	TOS, NOS;
begin
COMMENT($1E);
GENADD;
end;	\GENDBA



proc	GENSTD;		\$1F: @(NOS):= TOS
int	LEV, OFF, TOS, NOS;
begin
COMMENT($1F);
TOS:= PSTKTYP(PSTKPTR-1);
LEV:= PSTKLEV(PSTKPTR-1);
OFF:= PSTKOFF(PSTKPTR-1);
NOS:= PSTKTYP(PSTKPTR-2);

if TOS=IMMTYP & OFF=^C then
	begin
	PDROP(1);
	TOS2REG(^Y);
	GENAC(LEV, OFF);
	TTXT("	STA	(IY+0)|");
	PDROP(1);
	end
else	begin
	if NOS=REGTYP then
		begin
		if TOS=ADRTYP & LEV#LEVEL & LEV#0 then
			begin		\TOS = intermediate variable
			TTXT("	PSA|");
			TOS2REG(^A);	\this alters IY
			TTXT("	POY|");
			OLDLEV:= -1;
			end
		else	begin
			TTXT("	MAY|");
			OLDLEV:= -1;
			TOS2REG(^A);	\this does not alter IY (unless TOS is
			PDROP(2);	\ an intermediate variable)
			end;
		end
	else	begin
		TOS2REG(^A); PDROP(1);
		TOS2REG(^Y); PDROP(1);
		end;
	TTXT("	STA	(IY+0)|");
	end;
end;	\GENSTD



proc	DOINDEX1(PWR);	\Handle index generated for DBX and TRX
			\TOS:= @(NOS + TOS*2^PWR)
int	PWR;	\power of two
int	C;
begin
CLEANREG(2);
if PSTKTYP(PSTKPTR-1)=IMMTYP then
	begin
	C:= PSTKLEV(PSTKPTR-1);
	PDROP(1);
	TOS2REG(^Y); PDROP(1);
	TTXT("	LDA	(IY+"); INTOUT(BINDEV,C<<PWR); TTXT(")|");
	end
else	begin
	if PWR=0 then GENADD
	else	begin
		TOS2AC;
		for C:= 1, PWR do
			[TTXT("	SHL|");
			ACLEV:= -1; ACIMM:= false];
		PDROP(1);
		ADDTOS2AC;
		end;
	PDROP(1);
	TTXT("	MAY|	LDA	(IY+0)|");
	OLDLEV:= -1;
	end;
PPUSH(REGTYP, 0, 0);
ACLEV:= -1; ACIMM:= false;
end;	\DOINDEX1



proc	GENDBX;		\$20: TOS:= @(TOS + NOS)
begin
COMMENT($20);
DOINDEX1(0);
end;	\GENDBX



proc	GENADR(L, O);	\$21:
int	L, O;
begin
COMMENT($21);
CLEANREG(0);
NEWLEVEL(L);
if L = 0 then
	TTXT("	LDA	HEAPLO+")
else	begin
	if L = LEVEL then
		TTXT("	MXA|	ADD	")
	else	TTXT("	MYA|	ADD	");
	end;
INTOUT(BINDEV, O>>1); CRLF(BINDEV);
ACLEV:= -1; ACIMM:= false;
PPUSH(REGTYP, 0, 0);
end;	\GENADR



proc	GENCJP(L,SENSE);	\$25: 'case' jump
int	L,SENSE;
int	TOSTYP, TOSVAL, TOSOFF, NOSTYP;
begin
COMMENT($25);
\NOS is the value between 'case' and 'of' and it is on the stack
\TOS is the value of the label:
TOSTYP:= PSTKTYP(PSTKPTR-1);
TOSVAL:= PSTKLEV(PSTKPTR-1);
TOSOFF:= PSTKOFF(PSTKPTR-1);
NOSTYP:= PSTKTYP(PSTKPTR-2);

case TOSTYP of
  REGTYP,STKTYP: TOS2AC;
  ADRTYP: [OPSTRING("	LDA	&|", ^A, TOSVAL, TOSOFF, 0);
	  ACLEV:= TOSVAL; ACOFF:= TOSOFF; ACIMM:= false];
  IMMTYP: GENAC(TOSVAL, TOSOFF)
other	  BUGMSG("GENCJP");
PDROP(1);
TTXT("	SUB	(SP+0)|");
ACLEV:= -1; ACIMM:= false;
if SENSE then TTXT("	JOZ	L")
	 else	begin
		TTXT("	JNZ	L");
		ACIMM:= true; ACVAL:= 0;
		end;
INTOUT(BINDEV, L); CRLF(BINDEV);
end;	\GENCJP



proc	GENDRP(N);	\$28: Drop N values from stack
int	N;
int	I;
begin
COMMENT($28);
for I:= 1, N do
    if PSTKTYP(PSTKPTR-I)=STKTYP then
	TTXT("	INS|");
end;	\GENDRP



proc	GENFLOD(L, O);	\$2A: Floating load
int	L, O;
begin
COMMENT($2A);
O:= O >> 1;	\convert byte offset to word offset
CLEANREG(0);
OPSTRING("	LDA	&|	PSA", ^A, L, O+0, 0);
OPSTRING("	LDA	&|	PSA", ^A, L, O+1, 0);
OPSTRING("	LDA	&|	PSA", ^A, L, O+2, 0);
OPSTRING("	LDA	&|	PSA", ^A, L, O+3, 0);
PPUSH(REALTYP, 0, 0);
ACLEV:= -1; ACIMM:= false;
end;	\GENFLOD



proc	GENFSTO(L, O);	\$2B: Floating store
int	L, O;
begin
COMMENT($2B);
O:= O >> 1;	\convert byte offset to word offset
TTXT("	POA|");
ACLEV:= -1; ACIMM:= false;
OPSTRING("	STA	&|", ^A, L, O+3, 0);
OPSTRING("	POA|	STA	&|", ^A, L, O+2, 0);
OPSTRING("	POA|	STA	&|", ^A, L, O+1, 0);
OPSTRING("	POA|	STA	&|", ^A, L, O+0, 0);
PDROP(1);
end;	\GENFSTO



proc	GENFIMM(T, V);	\$2C: Load floating immediate value
int	T, V;
int	W, P;
begin
COMMENT($2C);
CLEANREG(0);
if T = ^C then
	begin
	P:= addr RLATOM;
	for W:= 0, RLSIZE/2-1 do
		begin
		GENAC(P(W),^C);
		TTXT("	PSA|");
		end
	end
else if T = ^L then
	begin
	TTXT("	LDA	L"); INTOUT(BINDEV, V);
	TTXT("|	PSA|");
	TTXT("	PSA|	PSA|	PSA|");
	ACLEV:= -1; ACIMM:= false;
	end
else	BUGMSG("GENFIMM");
PPUSH(REALTYP, 0, 0);
end;	\GENFIMM



proc	FMATH(T);	\$2D-$30: Floating point math
int	T;
int	OSTR;
begin
OSTR:= ["FADDDO|", "FSUBDO|", "FMULDO|", "FDIVDO|"];
COMMENT(T);
TTXT("	CSR	");
TTXT(OSTR(T-$2D));
OLDLEV:= -1;		\SUBROUTINE MIGHT HAVE DESTROYED REGISTERS
ACLEV:= -1;
ACIMM:= false;
PDROP(1);
end;	\FMATH



proc	GENMTH(T);	\Select real or integer math operations
int	T;
begin
if T > $10 then FMATH(T) else
	case T of
	  $0D:	GENADD;
	  $0E:	GENSUB;
	  $0F:	GENMUL;
	  $10:	GENDIV
	other;
end;	\GENMTH



proc	GENFNEG;	\$31: Floating negate
begin
COMMENT($31);
TTXT("	LDA	(SP+3)|	XOR	8000h|	STA	(SP+3)|");
ACLEV:= -1; ACIMM:= false;
end;	\GENFNEG



proc	GENTRA;		\$38: TOS:= TOS*4 + NOS
begin
COMMENT($38);
DOINDEX2(2);
TOS2HARD;	\must have TOS in hard value for following call to STTDO
end;	\GENTRA



proc	GENTRX;		\$39: TOS:= @(TOS*4 + NOS)
begin
COMMENT($39);
DOINDEX1(2);
end;	\GENTRX



proc	GENTRI;		\$3A: Real TOS:= @(TOS*4 + real NOS)
begin
COMMENT($3A);
TOS2AC;
TTXT("	CSR	TRIDO|");
PDROP(2);
PPUSH(REALTYP, 0, 0);
OLDLEV:= -1;		\subroutine might have destroyed registers
ACLEV:= -1;
ACIMM:= false;
end;	\GENTRI



proc	GENSTT;		\$3B: @(NOS):= real TOS
begin
COMMENT($3B);
TOS2STACK;
TTXT("	CSR	STTDO|");
PDROP(2);
OLDLEV:= -1;		\subroutine might have destroyed registers
ACLEV:= -1;
ACIMM:= false;
end;	\GENSTT



proc	GENMARK;	\$3C: Generate mark for procedure arguments
begin
COMMENT($3C);
end;	\GENMARK



proc	SHIFT(LEFT, LOP);	\Shift NOS by TOS bits 
int	LEFT, LOP, C;		\Only the low 4 bits of TOS are used
int	TOSTYP, NOSTYP, TOSVAL, NOSVAL;
begin
if ~IDENTITY(0,false) then
	begin
	TOSTYP:= PSTKTYP(PSTKPTR-1);
	NOSTYP:= PSTKTYP(PSTKPTR-2);
	TOSVAL:= PSTKLEV(PSTKPTR-1) & $000F;
	NOSVAL:= PSTKLEV(PSTKPTR-2);
	if TOSTYP=IMMTYP & NOSTYP=IMMTYP then
		begin
		TOSVAL:= if LEFT then NOSVAL<<TOSVAL else NOSVAL>>TOSVAL;
		PDROP(2);
		PPUSH(IMMTYP, TOSVAL, ^C);
		end
	else if TOSTYP=IMMTYP then		\TOS = amount to shift
		begin
		if LEFT & TOSVAL>=8 &
		    (LOP=\LDX\$02 ! LOP=\PIN\$4E) then
			TTXT("	ORG	$-2|");	\overwrite AND 00FFh
		CLEANREG(2);
		PDROP(1);
		TOS2AC;				\NOS into AC
		PDROP(1);
		if TOSVAL >= 8 then
			begin
			TTXT(if LEFT then "	BSL|" else "	BSR|");
			TOSVAL:= TOSVAL - 8;
			end;
		for C:= 0, TOSVAL-1 do
			TTXT(if LEFT then "	SHL|" else "	LSR|");
		PPUSH(REGTYP, 0, 0);
		ACLEV:= -1; ACIMM:= false;
		end
	else	begin				\TOS is not immediate
		TOS2AC; PDROP(1);
		TTXT("	AND	000Fh|	NEG|	ADD	");
		TTXT(if LEFT then "SHL0" else "LSR0");
		TTXT("|	STA	("); LOCOUT; TTXT("-1)|");
		TOS2AC; PDROP(1);
		TTXT("	CSR	12345|");
		LOCOUT; CRLF(BINDEV);
		LOCAL:= LOCAL+1;
		PPUSH(REGTYP, 0, 0);
		ACLEV:= -1; ACIMM:= false;
		end;
	end;
end;	\SHIFT



proc	GENLSL;		\$3E: NOS << TOS
int	LOP;
begin
LOP:= LASTOP;
COMMENT($3E);
SHIFT(true, LOP);
end;	\GENLSL



proc	GENLSR;		\$3F: NOS >> TOS
int	LOP;
begin
LOP:= LASTOP;
COMMENT($3F);
SHIFT(false, LOP);
end;	\GENLSR



proc	GENLDSI;	\$40: Load segment integer TOS:= @((TOS*2) SEG(NOS))
COMMENT($40);



proc	GENLDSB;	\$41: Load segment byte TOS:= @(TOS SEG(NOS))
COMMENT($41);



proc	GENLDSR;	\$42: Load segment real
COMMENT($42);



proc	GENSTSI;	\$43: Store segment integer @((NOS1*2) SEG(NOS2)):= TOS
COMMENT($43);



proc	GENSTSB;	\$44: Store segment byte @(NOS1 SEG(NOS2)):= TOS
COMMENT($44);



proc	GENSTSR;	\$45: Store segment real
COMMENT($45);



proc	GENLSHORT;	\$46: Load short real
COMMENT($46);



proc	GENSSHORT;	\$47: Store short real
COMMENT($47);



proc	GENARY;		\$48: Array declaration
begin
COMMENT($48);
TTXT("	CSR	MKARRAY|");
OLDLEV:= -1;		\subroutine might have destroyed registers
ACLEV:= -1;
ACIMM:= false;
end;	\GENARY



proc	GENABS;		\$49: Absolute value function
begin
COMMENT($49);
if PSTKTYP(PSTKPTR-1)=IMMTYP then
	PSTKLEV(PSTKPTR-1):= ABS(PSTKLEV(PSTKPTR-1))
else	begin
	CLEANREG(1);
	TOS2REG(^A);
	TTXT("	JPL	$+3|	NEG|");			\(beware of $8000)
	ACLEV:= -1; ACVAL:= ABS(ACVAL);
	PSTKTYP(PSTKPTR-1):= REGTYP;
	end;
end;	\GENABS



proc	GENFABS;	\$4A: Absolute value function of a real
begin
COMMENT($4A);
TTXT("	LDA	(SP+3)|	AND	7FFFh|	STA	(SP+3)|");
ACLEV:= -1; ACIMM:= false;
end;	\GENFABS



proc	GENREM;		\$4B: Remainder of last divide
begin			\TOS:= rem(Y/X)
COMMENT($4B);
PDROP(1);		\discard TOS
CLEANREG(0);
TTXT("	LDA	(REMAIN)|");
ACLEV:= -1; ACIMM:= false;
PPUSH(REGTYP, 0, 0);
end;	\GENREM



proc	GENSWAP;	\$4C: Swap bytes function
begin
COMMENT($4C);
if PSTKTYP(PSTKPTR-1)=IMMTYP then
	PSTKLEV(PSTKPTR-1):= SWAP(PSTKLEV(PSTKPTR-1))
else	begin
	CLEANREG(1);
	TOS2REG(^A);
	TTXT("	CSR	INTR4|");
	ACLEV:= -1; ACVAL:= SWAP(ACVAL);
	PSTKTYP(PSTKPTR-1):= REGTYP;
	end;
end;	\GENSWAP



proc	GENEXT;		\$4D: Sign extend function
begin
COMMENT($4D);
if PSTKTYP(PSTKPTR-1)=IMMTYP then
	PSTKLEV(PSTKPTR-1):= EXTEND(PSTKLEV(PSTKPTR-1))
else	begin
	CLEANREG(1);
	TOS2REG(^A);
	TTXT("	CSR	INTR5|");
	ACLEV:= -1; ACVAL:= EXTEND(ACVAL);
	PSTKTYP(PSTKPTR-1):= REGTYP;
	end;
end;	\GENEXT



proc	GENPIN;		\$4E: Function to read a byte from a port
begin			\TOS:= port(TOS);
COMMENT($4E);
CLEANREG(1);
if PSTKTYP(PSTKPTR-1)=IMMTYP then
	[TTXT("	INP	("); INTOUT(BINDEV, PSTKLEV(PSTKPTR-1)); TTXT(")|")]
else	[TOS2REG(^A); TTXT("	STA	($+3)|	INP	(12345)|")];
TTXT("	AND	00FFh|");
\Optimized GENSTX, GENJPC, SHIFT and GENPOUT depends on this AND instruction
ACLEV:= -1; ACIMM:= false;
PSTKTYP(PSTKPTR-1):= REGTYP;
end;	\GENPIN



proc	GENPOUT;	\$4F: Function to write a byte to a port
int	LOP;		\port(NOS):= TOS;
begin
LOP:= LASTOP;
COMMENT($4F);
if LOP=\LDX\$02 ! LOP=\PIN\$4E then
	TTXT("	ORG	$-2|");		\overwrite AND	00FFh
CLEANREG(1);
TOS2REG(^A);
if PSTKTYP(PSTKPTR-2)=IMMTYP then
	[TTXT("	OUT	("); INTOUT(BINDEV, PSTKLEV(PSTKPTR-2)); TTXT(")|")]
else	TTXT("	STA	($+3)|	OUT	(12345)|");
PDROP(2);
end;	\GENPOUT



proc	GENEND;		\$FE: End of XPL code
begin			\HEAPLO starts at end of data area
COMMENT($FE);
TTXT("|	ORG	DATA|HEAPLO	EQU	$|	END|");
end;	\GENEND

\===============================================================================

proc	LOOKUP;		\Lookup identifier in symbol table
\Inputs: IDENT, HASH
\Outputs: IDTYPE, VAL, LEV, SYMNUM.
\If two identifiers of the same name are in the symbol table then the most
\ recent entry is used.
int	I, K, PNTR;
begin
PNTR:= BOX(HASH);
loop	begin
	if PNTR=EMTPNT then [IDTYPE:= UNDEF; quit];
	I:= 0; K:= PNTR;
	while IDENT(I)=SYMBOL(K) & I<SIGCHAR do
		[I:= I+1; K:= K+SYMAX];
	if I=SIGCHAR then			\found
		[IDTYPE:= SYMTYP(PNTR);
		VAL:= SYMVAL(PNTR);
		LEV:= SYMLEV(PNTR);
		SYMNUM:= PNTR;			\(for forward proc)
		quit];
	PNTR:= SYMPNT(PNTR);
	end;
end;	\LOOKUP



proc	INSERT(STYP, SLEV, SVAL);
\Insert the current identifier into the symbol table
\Inputs:  STYP, SLEV, SVAL, IDENT, HASH, NOSYM, SYMBOL, & BOX.
int	STYP, SLEV, SVAL;
int	I, K;
begin
LOOKUP;
if IDTYPE # UNDEF then if LEV=LEVEL then \collision\ ERROR(11);
if NOSYM >= SYMAX then \table full\ [ERROR(3); NOSYM:= SYMAX-1];
K:= NOSYM;
for I:= 0, SIGCHAR-1 do [SYMBOL(K):= IDENT(I); K:= K+SYMAX];
SYMTYP(NOSYM):= STYP;
SYMLEV(NOSYM):= SLEV;
SYMVAL(NOSYM):= SVAL;
SYMPNT(NOSYM):= BOX(HASH);			\link back
BOX(HASH):= NOSYM;
NOSYM:= NOSYM+1;
end;	\INSERT



proc	GETCON;		\Get a constant--either by value or by name
int	NEG;
begin
if ATOM=^+ then RATOM;
if ATOM=^- then [NEG:= true; RATOM] else NEG:= false;
case ATYPE of
  INTCON:
	[if NEG then IATOM:= -IATOM;
	FACTYP:= INTEGER];
  REALCON:
	[if NEG then RLATOM:= -RLATOM;
	FACTYP:= REAL];
  IDENTIFIER:
	begin
	LOOKUP;
	case IDTYPE of
	 INCON:	[IATOM:= if NEG then -VAL else VAL;
		FACTYP:= INTEGER];
	 RLCON:	[RLATOM:= if NEG then-RLTBL(VAL) else RLTBL(VAL);
		FACTYP:= REAL]
	other	ERROR(42);
	end
other	ERROR(42);
end;	\GETCON

\-------------------------------------------------------------------------------

proc	CONEXPRESS;	\Evaluate constant expressions
\Outputs: FACTYP, IATOM, RLATOM
int	SFACTYP, ITEMP, IFVAR;
real	RTEMP;


	proc INTTEST;		\Test for integer errors
	if FACTYP # INTEGER then ERROR(47);


	proc MIXTEST(TYPE);	\Test for mixed-mode errors
	int TYPE;
	if TYPE#FACTYP then ERROR(46);


	proc	CFACTOR;
	begin
	if ATOM=^( then
		begin
		RATOM;
		CONEXPRESS;
		if ATOM#^) then ERROR(44);		
		end
	else GETCON;
	RATOM;
	end;	\CFACTOR


	proc	CSHIFTEXP;
	int	ITEMP;
	begin
	CFACTOR;
	ITEMP:=IATOM;
	case ATOM of
	LSLSYM:	begin
		INTTEST;
		RATOM;
		CFACTOR;
		INTTEST;
		IATOM:=ITEMP << IATOM;
		end;	
	LSRSYM:	begin
		INTTEST;
		RATOM;
		CFACTOR;
		INTTEST;
		IATOM:=ITEMP >> IATOM;
		end
	other;
	end;	\CSHIFTEXP


	proc	CTERM;
	int	SFACTYP;
	int	ITEMP;
	real	RTEMP;
	begin
	CSHIFTEXP;
	SFACTYP:=FACTYP;
	loop	begin
		ITEMP:=IATOM;RTEMP:=RLATOM;
		case ATOM of
		  ^*:	begin
			RATOM;
			CSHIFTEXP;
			MIXTEST(SFACTYP);
			if FACTYP=INTEGER then IATOM:=ITEMP * IATOM
				else RLATOM:=RTEMP * RLATOM;
			end;
		  ^/:	begin
			RATOM;
			CSHIFTEXP;
			MIXTEST(SFACTYP);
			if IATOM=0 ! RLATOM=0.0 then ERROR(73) \Divide by zero
			else if FACTYP=INTEGER then IATOM:=ITEMP / IATOM
				else RLATOM:=RTEMP / RLATOM;
			end
		other	quit;
		end;
	end;	\CTERM


	proc	CALGEXP;	\Algebriac expression
	int	SFACTYP;
	int	ITEMP;
	real	RTEMP;
	begin
	CTERM;
	SFACTYP:=FACTYP;
	loop	begin
		ITEMP:=IATOM;RTEMP:=RLATOM;
		case ATOM of
		  ^+:	begin
			RATOM;
			CTERM;
			MIXTEST(SFACTYP);
			if FACTYP=INTEGER then IATOM:=ITEMP + IATOM
			else RLATOM:=RTEMP + RLATOM;
			end;
		  ^-:	begin
			RATOM;
			CTERM;
			MIXTEST(SFACTYP);
			if FACTYP=INTEGER then IATOM:=ITEMP - IATOM
				else RLATOM:=RTEMP - RLATOM;
			end
		other	quit;
		end;
	end;	\CALGEXP


	proc	CLOGEXP;	\'not' and comparisons
	int	SFACTYP;
	int	ITEMP;
	real	RTEMP;
	begin
	if ATOM=NOTSYM ! ATOM=^~ then		\unary 'not' operator
		begin
		RATOM;
		CLOGEXP;
		INTTEST;
		IATOM:= ~IATOM;
		end
	else	begin
		CALGEXP;
		SFACTYP:=FACTYP;
		ITEMP:=IATOM; RTEMP:=RLATOM;
		case ATOM of
		 ^=:	[RATOM;
			CALGEXP;
			MIXTEST(SFACTYP);
			if FACTYP=INTEGER then IATOM:= ITEMP = IATOM
			else IATOM:= RTEMP = RLATOM;
			FACTYP:=INTEGER];
		 ^#:	[RATOM;
			CALGEXP;
			MIXTEST(SFACTYP);
			if FACTYP=INTEGER then IATOM:= ITEMP # IATOM
			else IATOM:= RTEMP # RLATOM;
			FACTYP:=INTEGER];
		 ^>:	[RATOM;
			CALGEXP;
			MIXTEST(SFACTYP);
			if FACTYP=INTEGER then IATOM:= ITEMP > IATOM
			else IATOM:= RTEMP > RLATOM;
			FACTYP:=INTEGER];
		 ^<:	[RATOM;
			CALGEXP;
			MIXTEST(SFACTYP);
			if FACTYP=INTEGER then IATOM:= ITEMP < IATOM
			else IATOM:= RTEMP < RLATOM;
			FACTYP:=INTEGER];
		 GESYM:	[RATOM;
			CALGEXP;
			MIXTEST(SFACTYP);
			if FACTYP=INTEGER then IATOM:= ITEMP >= IATOM
			else IATOM:= RTEMP >= RLATOM;
			FACTYP:=INTEGER];
		 LESYM:	[RATOM;
			CALGEXP;
			MIXTEST(SFACTYP);
			if FACTYP=INTEGER then IATOM:= ITEMP <= IATOM
			else IATOM:= RTEMP <= RLATOM;
			FACTYP:=INTEGER]
		other	[];
		end;
	end;	\CLOGEXP


	proc	CBOOLTERM;	\Boolean "&" expressions
	int	ITEMP;
	begin
	CLOGEXP;
	loop	begin
		ITEMP:=IATOM;
		if ATOM=^& then
			begin
			INTTEST;
			RATOM;
			CLOGEXP;
			INTTEST;
			IATOM:=ITEMP & IATOM;
			end
		else quit;
		INTTEST;
		end;
	end;	\CBOOLTERM


begin	\CONEXPRESS
TRAP(false);
if ATOM=IFSYM then		\'if' expression
	begin
	RATOM;
	CONEXPRESS;
	INTTEST;
	IFVAR:=IATOM;
	if ATOM#THENYM then ERROR(22);
	RATOM;
	CONEXPRESS;
	SFACTYP:=FACTYP;
	ITEMP:=IATOM; RTEMP:=RLATOM;
	if ATOM#ELSEYM then ERROR(30);
	RATOM;
	CONEXPRESS;
	MIXTEST(SFACTYP);
	if IFVAR then 
		if FACTYP=INTEGER then IATOM:=ITEMP
		else RLATOM:=RTEMP;
	end
else	begin
	CBOOLTERM;
	loop	begin
		ITEMP:=IATOM;
		case ATOM of
		  ^!:	begin
			INTTEST;
			RATOM;
			CBOOLTERM;
			INTTEST;
			IATOM:=ITEMP ! IATOM;
			end;
		  ^|:	begin
			INTTEST;
			RATOM;
			CBOOLTERM;
			INTTEST;
			IATOM:=ITEMP | IATOM;
			end
		other quit;
		end;
	end;
TRAP(true);
if GETERR#0 then ERROR(74);	\general math error
end;	\CONEXPRESS

\-------------------------------------------------------------------------------

fproc	BOOLEXP;



proc	PROCAL(FUNC);
int	FUNC;	\true if function, vs. procedure
int	SVAL, SLEV, ARGCNT, BYTES, SID, CURSYM;
begin
SVAL:= VAL; SLEV:= LEV; SID:= IDTYPE; CURSYM:= SYMNUM;
RATOM;
ARGCNT:= 0;
BYTES:= 0;
CLEANREG(0);
if ATOM=^( then
	begin
	\Mark the start of argument generation
	if SID>=INPROC & SID<=RLFPROC then GENMARK;
	loop	begin
		RATOM;
		BOOLEXP;
		ARGCNT:= ARGCNT+1;
		BYTES:= BYTES + (if FACTYP=INTEGER then 2 else RLSIZE);
		if ATOM # ^, then quit;
		if SID>=INPROC & SID<=RLFPROC then []	\use pseudo stack for procs
		else if FACTYP=INTEGER then TOS2STACK;	\use H/W stack for others
		end;
	if ATOM#^) then ERROR(44) else RATOM;
	end;
case of
  SID>=INPROC & SID<=RLFPROC:				\normal procedure call
	[if ARGCNT>0 then GENARG(BYTES);
	GENCAL(SVAL, false)]

other	case SID of
	  ININT, RLINT:	GENCML(SVAL,FACTYP,SID,FUNC,ARGCNT); \intrinsic procedure call
	  INOPT, RLOPT:					\optimized procedure call
		[if ARGCNT>0 then ERROR(51);		\no arguments declared
		GENJSR(SVAL)];
	  INEXT, RLEXT:	GENCEXT(CURSYM,FACTYP,SID,FUNC,ARGCNT);	\external assembly call
	  INEPRO, RLEPRO:					\external XPL call
		[if ARGCNT>0 then GENARG(BYTES);
		GENCAL(CURSYM, true)]
	other;
end;	\PROCAL



proc	FACTOR;



func	STRCON;		\String constant function
int	SPC;
int	C,NCHAR,DONE;

	proc	NEXTC;
	begin
	CHAR:= NCHAR; NCHAR:= CHIN(SRCDEV); CHOUT(LSTDEV,NCHAR);
	if NCHAR=^^ then
		begin
		NCHAR:= CHIN(SRCDEV); CHOUT(LSTDEV,NCHAR);
		if NCHAR>=^@ & NCHAR<=^_ & NCHAR#^^ then NCHAR:= NCHAR-^@;
		if NCHAR>=^` & NCHAR<=^~ then NCHAR:= NCHAR-^`;
		end
	else if NCHAR=^" then [CHAR:= CHAR!$80; DONE:= true];
	end;	\NEXTC


	proc	BINMODE;	\Output string character as binary decimal
	begin
	if C#0 then CHOUT(BINDEV,^,);
	INTOUT(BINDEV,CHAR);
	C:= C+1;
	end;	\BINMODE


	proc	ASCMODE;	\Output string character as ASCII
	begin
	if C#0 then CHOUT(BINDEV,^,);
	CHOUT(BINDEV,^");
	CHOUT(BINDEV,CHAR);
	CHOUT(BINDEV,^");
	C:= C+1;
	end;	\ASCMODE

begin	\STRCON
COMMENT($FB);
SPC:= NEWLAB;
DLABEL(SPC);

if CHAR=^^ then
	begin
	CHAR:= CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	if CHAR>=^@ & CHAR<=^_ & CHAR#^^ then CHAR:= CHAR-^@;
	if CHAR>=^` & CHAR<=^~ then CHAR:= CHAR-^`;
	end;
NCHAR:= CHAR;
DONE:= false;
C:= 0;
loop	begin
	NEXTC;
	if NCHAR=EOF then [ERROR(63); exit 1];
	if C=0 then TTXT("	DWM	");

	case of
	  CHAR=^',CHAR=^": BINMODE;
	  CHAR>$1F: ASCMODE
	other BINMODE;
	if DONE then quit;

	if C>=20 then	\maximum number of items per line assembler can handle
		begin
		CRLF(BINDEV);
		C:= 0;
		end;
	end;
CRLF(BINDEV);

GETCH;
FACTYP:= INTEGER;
return SPC;		\return starting address of string
end;	\STRCON



func	ARRAYCON;	\Constant arrays
int	THISEL, NEXTEL, PNTR, SPC, I, INDIRECT, SFACTYP;
def	NULL=$FFFF;
char	ENTRY, R;

	proc	ARRAYX;	\(WARNING: This must be an optimized procedure
	begin		\ for the Reserve to work properly.)
	RATOM;
	INDIRECT:= true;
	case ATOM of
	  ^[:	[ENTRY:= ARRAYCON; RATOM];
	  ^":	[ENTRY:= STRCON; RATOM]
	other	begin
		INDIRECT:= false;
		CONEXPRESS;
		if FACTYP=INTEGER then ENTRY:= IATOM
		else	[ENTRY:= RESERVE(RLSIZE);  \FACTYP=REAL
			R:= addr RLATOM;
			for I:= 0, RLSIZE-1 do ENTRY(I):= R(I)];
		end;
	NEXTEL:= RESERVE(6);
	THISEL(1):= ENTRY;
	THISEL(2):= INDIRECT;
	THISEL(0):= NEXTEL;
	NEXTEL(0):= NULL;
	THISEL:= NEXTEL;
	end;	\ARRAYX


begin	\ARRAYCON
PNTR:= RESERVE(6);
THISEL:= PNTR;
THISEL(0):= NULL;
ARRAYX;
while ATOM=^, do
	[SFACTYP:= FACTYP;
	ARRAYX;
	if FACTYP#SFACTYP then \mixed mode\ ERROR(46)];
if ATOM#^] then ERROR(50);
COMMENT(if FACTYP=INTEGER then $FD else $FC);

SPC:= NEWLAB;
DLABEL(SPC);
while PNTR(0)#NULL do			\dump list
	begin
	ENTRY:= PNTR(1);
	if FACTYP=INTEGER then
		begin
		TTXT("	DWM	");
		if PNTR(2) \indirect\ then CHOUT(BINDEV, ^L);
		INTOUT(BINDEV, ENTRY);
		end
	else	begin			\(FACTYP=REAL)
		if PNTR(2) \indirect\ then
			begin
			TTXT("	DWM	L");
			INTOUT(BINDEV, ENTRY);
			TTXT("|	DWM	0,0,0|" );
			end
		else	begin
			TTXT("	DFB	");
			for I:= 0,RLSIZE-1 do
				begin
				CHOUT(BINDEV,^0);
				HEXB(ENTRY(I));
				CHOUT(BINDEV,^h);
				if I < RLSIZE-1 then CHOUT(BINDEV,^,);
				end;
			CRLF(BINDEV);
			end;
		end;
	PNTR:= PNTR(0);
	CRLF(BINDEV);
	end;
return SPC;		\return starting address of array
end;	\ARRAYCON



proc	SPECFAC;	\Special character factor
int	SVAL, SPC, R, SID;
begin
case ATOM of
  ^(:	[RATOM;				\parenthesized expression
	BOOLEXP;			\(factor type is unchanged)
	if ATOM#^) then ERROR(44);
	RATOM];
  ^":	[DSTART;			\string constant
	SVAL:= STRCON;
	DEND;
	GENIMM(^L, SVAL);
	RATOM];
  ^[:	[DSTART;			\constant array
	SVAL:= ARRAYCON;
	DEND;
	if FACTYP=INTEGER then GENIMM(^L, SVAL)
	else GENFIMM(^L, SVAL);		\FACTYP=REAL
	RATOM];
  ADRSYM:
	begin				\get address of variable in the heap
	RATOM;
	if ATYPE#IDENTIFIER then ERROR(45);
	LOOKUP;
	case IDTYPE of
	  INVAR, RLVAR, ADDRVAR:
		begin
		SID:= IDTYPE;
		RATOM;
		if ATOM=^( then			\indexed
			begin
			GENLOD(LEV, VAL);	\(even for reals)
			RATOM;
			BOOLEXP;		\first index
			if FACTYP#INTEGER then ERROR(47);
			while ATOM=^, do	\multiple indexing
				begin
				case SID of
				  INVAR, ADDRVAR: GENDBX;
				  RLVAR: GENTRX
				other [];
				RATOM;
				BOOLEXP;
				if FACTYP#INTEGER then ERROR(47);
				end;
			case SID of
			  INVAR: GENDBA;
			  RLVAR: GENTRA;
			  ADDRVAR: GENADD
			other [];
			if ATOM#^) then ERROR(44) else RATOM;
			end
		else	GENADR(LEV, VAL);
		end;
	  UNDEF:	ERROR(10)		\(undeclared name)
	other		ERROR(43);		\(variable expected)
	FACTYP:= INTEGER;
	end;
  ABSSYM:
	begin					\absolute value function
	RATOM;
	if ATOM#^( then ERROR(39) else RATOM;
	BOOLEXP;
	if FACTYP=INTEGER then GENABS else GENFABS;
	if ATOM#^) then ERROR(44) else RATOM;
	end;
  REMSYM:
	begin					\remainder of last divide
	RATOM;
	if ATOM#^( then ERROR(39) else RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	GENREM;
	if ATOM#^) then ERROR(44) else RATOM;
	end;
  SWAPYM:
	begin					\swap bytes function
	RATOM;
	if ATOM#^( then ERROR(39) else RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	GENSWAP;
	if ATOM#^) then ERROR(44) else RATOM;
	end;
  EXTSYM:
	begin					\sign extend function
	RATOM;
	if ATOM#^( then ERROR(39) else RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	GENEXT;
	if ATOM#^) then ERROR(44) else RATOM;
	end;
  PORTYM:
	begin					\read byte from port
	RATOM;
	if ATOM#^( then ERROR(39) else RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	GENPIN;
	if ATOM#^) then ERROR(44) else RATOM;
	end
other	\illegal factor\ ERROR(26);
end;	\SPECFAC



proc	IDFAC;		\Identifier factor
int	SLEV, SVAL, SID, SINDX;
begin
LOOKUP;
SID:= IDTYPE;
case IDTYPE of
 UNDEF:	ERROR(10);

 INVAR, RLVAR, ADDRVAR:				\variable
	begin
	if SID=RLVAR then GENFLOD(LEV,VAL) else GENLOD(LEV,VAL);
	RATOM;
	if ATOM=^( then				\it is indexed
		begin
		loop	begin
			RATOM;
			BOOLEXP;
			if FACTYP#INTEGER then ERROR(47);
			if ATOM#^, then quit;
			if SID=RLVAR then GENTRI else GENDBX;
			end;
		if ATOM#^) then ERROR(44) else RATOM;
		case SID of
		 INVAR:   GENDBX;
		 RLVAR:   GENTRI;
		 ADDRVAR: GENLDX
		other	[];
		end;
	end;

 INSEG, RLSEG, ADSEG, SHSEG:			\segment variable
	begin
	SINDX:= 0;				\watch index level
	GENLOD(LEV, VAL);
	RATOM;
	if ATOM=^( then				\handle first index
		begin
		RATOM;
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		GENDBX;
		if ATOM=^, then			\handle second index
			begin
			SINDX:= 2;		\flag two indexes
			RATOM;
			BOOLEXP;
			if FACTYP#INTEGER then ERROR(47);
			case SID of
				INSEG: GENLDSI;
				ADSEG: GENLDSB;
				RLSEG: GENLDSR;
				SHSEG: GENLSHORT
			other;
			end;
		if ATOM#^) then ERROR(44) else RATOM;
		end;
	\Force real to be integer when there are less than 2 indexes
	case SID of RLSEG, SHSEG: [if SINDX<2 then SID:= INSEG] other;
	end;

 INCON:	begin					\integer constant identifier
	GENIMM(^C, VAL);
	RATOM;
	end;

 RLCON:	begin					\real constant identifier
	RLATOM:= RLTBL(VAL); GENFIMM(^C, 0);
	RATOM;
	end

other	begin					\procedures used as functions
	PROCAL(true);
	if SID<ININT then		\integer functions return values in AC
		if SID&1 then [PPUSH(REGTYP, 0, 0)]
		else GENFLOD(0, 0);
	end;

FACTYP:= if SID & 1 then INTEGER else REAL;	\odd numbered IDs are integer
end;	\IDFAC



begin	\FACTOR
while ATOM=^+ do RATOM;				\ignore unary "+"
if ATOM=^- then					\unary "-"
	begin
	RATOM;
	FACTOR;
	if FACTYP=INTEGER then GENNEG else GENFNEG;
	end
else	case ATYPE of
	  SPECIAL:	SPECFAC;
	  INTCON:	[FACTYP:= INTEGER;	\integer constant
			GENIMM(^C, IATOM);
			RATOM];
	  REALCON:	[FACTYP:= REAL;		\real constant
			GENFIMM(^C, 0);
			RATOM]
	other		IDFAC;			\ATYPE = identifier (by default)
end;	\FACTOR



proc	SHIFTEXP;

	proc	SHIFTX(INOP);
	int	INOP;
	begin
	if FACTYP # INTEGER then \integer expected\ ERROR(47);
	RATOM; FACTOR;
	if FACTYP # INTEGER then ERROR(47);
	end;	\SHIFTX

begin	\SHIFTEXP
FACTOR;
case ATOM of
  LSLSYM: [SHIFTX; GENLSL];	\<<
  LSRSYM: [SHIFTX; GENLSR]	\>>
other;
end;	\SHIFTEXP



proc	TERM;
int	SFACTYP;

	proc	TERMX(INOP, RLOP);
	int	INOP, RLOP;
	begin
	RATOM; SHIFTEXP;
	if SFACTYP#FACTYP then \mixed mode\ ERROR(46);
	GENMTH(if FACTYP=INTEGER then INOP else RLOP);
	end;	\TERMX

begin	\TERM
SHIFTEXP;
SFACTYP:= FACTYP;
loop	case ATOM of
	  ^*:	TERMX(\MUL\$0F, \MULF\$2F);
	  ^/:	TERMX(\DIV\$10, \DIVF\$30)
	other	quit;
end;	\TERM



proc	ALGEXP;		\Algebraic expression
int	SFACTYP;

	proc	ALGX(INOP, RLOP);
	int	INOP, RLOP;
	begin
	RATOM; TERM;
	if SFACTYP#FACTYP then \mixed mode\ ERROR(46);
	GENMTH(if FACTYP=INTEGER then INOP else RLOP);
	end;

begin	\ALGEXP
TERM;
SFACTYP:= FACTYP;
loop	case ATOM of
	  ^+:	ALGX(\ADD\$0D, \ADDF\$2D);
	  ^-:	ALGX(\SUB\$0E, \SUBF\$2E)
	other	quit;
end;	\ALGEXP



proc	LOGEXP;		\Logical expression
int	SFACTYP;

	proc	LOGX(INOP, RLOP);
	int	INOP, RLOP;
	begin
	RATOM; ALGEXP;
	if SFACTYP#FACTYP then \mixed mode\ ERROR(46);
	GENCMP(if FACTYP=INTEGER then INOP else RLOP);
	FACTYP:= INTEGER;
	end;

begin	\LOGEXP
if ATOM=NOTSYM ! ATOM=^~ then			\unary 'not' operator
	begin
	RATOM; LOGEXP;
	if FACTYP#INTEGER then ERROR(47);
	GENNOT
	end
else	begin
	ALGEXP;
	SFACTYP:= FACTYP;
	case ATOM of
	  ^=:	LOGX(\EQ\$12, \EQF\$32);
	  ^#:	LOGX(\NE\$13, \NEF\$33);
	  ^>:	LOGX(\GT\$15, \GTF\$35);
	  ^<:	LOGX(\LT\$17, \LTF\$37);
	  GESYM:LOGX(\GE\$14, \GEF\$34);
	  LESYM:LOGX(\LE\$16, \LEF\$36)
	other;
	end;
end;	\LOGEXP



proc	BOOLTERM;	\Boolean "&" expressions
begin
LOGEXP;
loop	[if ATOM=^& then [RATOM; LOGEXP; GENAND]
	else quit;
	if FACTYP#INTEGER then ERROR(47)];
end;	\BOOLTERM




func	SHORTER(LT, LF); \Short-circuit evaluate boolean expressions
int	LT, LF;		\labels to jump to if boolean expression is true or false
int	LTUSED, LFUSED;	\flags

\if LOGEXP then STATEMENT
\LABELS:       ^LT       ^LF
\EXAMPLE:
\if N=1  !  N=2  !  N=3 & N=4 & N=5  !  N=6  !  N=7 then ...
\
\		CMP	N,1
\		JE	LT
\		CMP	N,2
\		JE	LT
\
\		CMP	N,3
\		JNE	LF0
\		CMP	N,4
\		JNE	LF0
\		CMP	N,5
\		JE	LT
\	LF0:				;Initial false label
\		CMP	N,6
\		JE	LT
\		CMP	N,7
\		JNE	LF1
\	LT:				;There is only one true label
\		CALL	STATEMENT
\	LF1:				;Final false label is returned

begin
LTUSED:= false;
LFUSED:= false;
loop	begin
	RATOM;
	LOGEXP;
	loop	begin
		if ATOM=^& then
			begin	\beware of masking, e.g: if F & 3 then ...
			if LASTOP>=$12 & LASTOP<=$17 then	\comparison
				begin
				GENJPC(LF,false);	\jump to false label
				LFUSED:= true;		\label is used
				RATOM; LOGEXP;
				end
			else	[RATOM; LOGEXP; GENAND]; \old way
			end
		else quit;
		end;
	case ATOM of
	  ^!:	begin
		GENJPC(LT,true);	\conditionally jump to true label
		LTUSED:= true;		\indicate that true label was used
		if LFUSED then		\if there is a conditional jump using
			begin		\ this label then...
			CLABEL(LF);	\make label for false destination
			LF:= NEWLAB;	\make another false label
			LFUSED:= false;	\this one isn't used yet
			end;
		end;
	  ^|, IFSYM:	\must use parentheses for XOR and 'if' expressions
		ERROR(75)
	other	quit;
	end;
GENJPC(LF,false);
if LTUSED then CLABEL(LT);		\only make label if it is actually used
return LF;				\return (possibly new) false label
end;	\SHORTER



proc	BOOLEXP;	\Boolean expression. Outputs factor type (FACTYP).
int	P1, P2, P3, SFACTYP;


	proc	IFEXP;
	begin				\if BOOLEXP then BOOLEXP else BOOLEXP
	CLEANREG(0);
	if SHORTBOOL then		\Labels:      P1^     P2^          P3^
		begin
		P1:= NEWLAB;		\true label
		P2:= NEWLAB;		\false label
		P2:= SHORTER(P1, P2);	\returns false label (might be different)
		end
	else	begin
		RATOM;
		BOOLEXP;
		P2:= NEWLAB;		\false label
		GENJPC(P2,false);	\skip statement if BOOLEXP is false
		end;

	if ATOM # THENYM then ERROR(22);
	RATOM;
	BOOLEXP;
	SFACTYP:= FACTYP;
	if FACTYP = INTEGER then TOS2AC;
	PDROP(1);			\a lie, but it gets fixed below
	if ATOM # ELSEYM then ERROR(30);
	P3:= NEWLAB;
	GENJMP(P3);
	CLABEL(P2);

	RATOM;
	BOOLEXP;
	if FACTYP=INTEGER then TOS2AC;
			\pseudo stack must be in same state for each code path
	if SFACTYP#FACTYP then \mixed mode\ ERROR(46);
	CLABEL(P3);
	end;



	proc	BEXPX(INOP);
	int	INOP;
	begin
	if FACTYP # INTEGER then \integer expected\ ERROR(47);
	RATOM; BOOLTERM;
	if FACTYP # INTEGER then ERROR(47);
	end;	\BEXPX


begin
if ATOM=IFSYM then IFEXP		\'if' expression
else	begin				\boolean "!" (or) expressions
	BOOLTERM;
	loop	case ATOM of
		  ^!:	[BEXPX; GENOR];
		  ^|:	[BEXPX; GENEOR]
		other quit;
	end;
end;	\BOOLEXP

\-------------------------------------------------------------------------------

proc	SSTATEMENT(SSTK);	\(For 'quit's in 'case' statements)
int	SSTK;



proc	STATEMENT;
int	P1, P2, P3, SFIXS, SLEV, SVAL, SFACTYP, I,
	LOPARAMS, HIPARAMS, FLAG;



proc	ASSIGN;		\Assignment statement (also includes procedure calls)
int	SID;

	proc	ASSX;
	begin
	if ATOM#GETSYM then ERROR(21);
	RATOM;
	BOOLEXP;			\right-hand side of assignment
	end;

begin	\ASSIGN
if ATOM=PORTYM then			\port($123):= boolexp
	begin
	RATOM;
	if ATOM#^( then ERROR(39) else RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	if ATOM#^) then ERROR(44) else RATOM;
	ASSX;
	GENPOUT;
	if FACTYP#INTEGER then ERROR(47);
	return;
	end;

if ATYPE#IDENTIFIER then		\illegal start of a statement
	[ERROR(20); SKIPIT; return];
LOOKUP; if IDTYPE=UNDEF then [ERROR(10); SKIPIT; return];
SLEV:= LEV; SVAL:= VAL;			\save these for "GEN". An interim
SID:= IDTYPE;				\ boolexp in ASSX changes LEV & VAL

case of
  IDTYPE>=INPROC & IDTYPE<=RLEXT:
	PROCAL(false);

  IDTYPE=INVAR ! IDTYPE=RLVAR ! IDTYPE=ADDRVAR:
	begin
	SFACTYP:=if IDTYPE=RLVAR then REAL else INTEGER;
	RATOM;
	if ATOM=^( then			\indexed
		begin
		GENLOD(SLEV, SVAL);	\(even for reals)
		RATOM;
		BOOLEXP;		\first index
		if FACTYP#INTEGER then ERROR(47);

		while ATOM=^, do	\multiple indexing
			begin
			if SFACTYP=INTEGER then GENDBX else GENTRX;
			RATOM;
			BOOLEXP;
			if FACTYP#INTEGER then ERROR(47);
			end;
		if ATOM#^) then ERROR(44) else RATOM;
		case SID of
		 INVAR:   GENDBA;
		 RLVAR:   GENTRA;
		 ADDRVAR: GENADD
		other	[];

		ASSX;			\NOS now points to array element
		case SID of
		 INVAR:   GENSTD;
		 RLVAR:   GENSTT;
		 ADDRVAR: GENSTX
		other	[];
		end

	else	[ASSX;
		if SFACTYP=INTEGER then GENSTO(SLEV, SVAL)
		else GENFSTO(SLEV, SVAL)];

	if FACTYP#SFACTYP then \mixed mode\ ERROR(46);
	end;

  IDTYPE=INSEG ! IDTYPE=RLSEG ! IDTYPE=ADSEG ! IDTYPE=SHSEG:	\segment variables
	begin
	SFACTYP:= INTEGER;
	RATOM;
	if ATOM#^( then	[ASSX; GENSTO(SLEV, SVAL)]
	else	begin			\first index
		GENLOD(SLEV, SVAL);
		RATOM;
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		if ATOM=^, then		\second index
			begin
			GENDBX;
			case SID of RLSEG, SHSEG: TOS2HARD other;
			RATOM; BOOLEXP;
			if FACTYP#INTEGER then ERROR(47);
			if ATOM#^) then ERROR(44) else RATOM;
			case SID of RLSEG, SHSEG: TOS2HARD other;
			ASSX;		\get right side of assignment
			case SID of
			 INSEG:	GENSTSI;
			 RLSEG:	[GENSTSR; SFACTYP:= REAL];
			 ADSEG:	GENSTSB;
			 SHSEG:	[GENSSHORT; SFACTYP:= REAL]
			other;
			end
		else	begin
			GENDBA;
			if ATOM#^) then ERROR(44) else RATOM;
			ASSX;		\get right side of assignment
			GENSTD;
			end;
		end;
	if FACTYP#SFACTYP then \mixed mode\ ERROR(46);
	end

other	\statement starting with a constant\ [ERROR(27); SKIPIT];
end;	\ASSIGN



proc	CASER(TYPE);
int	TYPE;
int	SPC1, SPC2, SPC3, MULTILABEL;
begin
if TYPE = $25\CJP\ then TOS2STACK;
SPC2:= NEWLAB;
repeat	MULTILABEL:= false;
	loop	begin
		RATOM;			\case label:
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#^, then quit;
		if ~MULTILABEL then
			[SPC3:= NEWLAB;
			MULTILABEL:= true];
		if TYPE=$08 then GENJPC(SPC3,true) else GENCJP(SPC3,true);
		end;
	SPC1:= NEWLAB;
	if TYPE=$08 then GENJPC(SPC1,false) else GENCJP(SPC1,false);
	if MULTILABEL then CLABEL(SPC3);
	if ATOM#^: then [ERROR(49); SKIPIT; return];
	RATOM;
	STATEMENT;
	GENJMP(SPC2);			\jump out of case statement
	CLABEL(SPC1);
until ATOM#^;;

if ATOM#ELSEYM & ATOM#OTHSYM then ERROR(29);
RATOM;
STATEMENT;
CLABEL(SPC2);
end;	\CASER



begin	\STATEMENT
case ATOM of
BEGSYM, ^[:
	begin
	RATOM;
	loop	begin
		if ATOM=ELSEYM then [ERROR(52); RATOM];
		if ATOM=OTHSYM then [ERROR(53); RATOM];
		STATEMENT;
		case ATOM of
		  ^;:	RATOM;
		  ENDSYM, ^]:
			quit;
		  EOF:	[ERROR(62); exit 1]
		other	\semicolon expected\ ERROR(41);
		end;
	RATOM;		\read past the 'end'
	end;

CASEYM:	begin				\'case' statement
	RATOM;
	if ATOM=OFSYM then CASER(\JPC\$08)
	else	begin
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#OFSYM then [ERROR(48); SKIPIT; return];
		STKLOD:= STKLOD+1;
		CASER(\CJP\$25);
		GENDRP(1);
		PDROP(1);
		STKLOD:= STKLOD-1;
		end;
	end;

QUITYM:	begin
	GENDRP(STKLOD-SSTK);
	if FIXCNT>=QUITMAX then [ERROR(4); FIXCNT:= QUITMAX-1];
	FIXES(FIXCNT):= NEWLAB;		\quit statement
	GENJMP(FIXES(FIXCNT));   	\(will be "fixed" at end of 'loop')
	FIXCNT:= FIXCNT+1;
	RATOM;
	end;

IFSYM:	begin				\if BOOLEXP then STATEMENT
	if SHORTBOOL then		\Labels:      P1^       P2^
		begin
		P1:= NEWLAB;		\true label
		P2:= NEWLAB;		\false label
		P2:= SHORTER(P1, P2);	\returns false label (might be different)
		end
	else	begin
		RATOM;
		BOOLEXP;
		P2:= NEWLAB;		\false label
		GENJPC(P2,false);	\skip statement if boolexp is false
		end;
	if ATOM # THENYM then [ERROR(22); SKIPIT; return];
	RATOM;
	STATEMENT;
	if ATOM = ELSEYM then
		begin			\if BOOLEXP then STATEMENT else STATEMENT
		P3:= NEWLAB;		\Labels:      P1^       P2^            P3^
		GENJMP(P3);
		CLABEL(P2);
		P2:= P3;		\change name of P2 exit label to be P3
		RATOM;
		STATEMENT;
		end;
	CLABEL(P2);
	end;

REPSYM:	begin
	P2:= NEWLAB;			\'repeat' statement
	CLABEL(P2);
	repeat RATOM; STATEMENT until ATOM#^;;
	if ATOM#UNTSYM then [ERROR(28); SKIPIT; return];
	RATOM;
	BOOLEXP;
	GENJPC(P2,false);
	end;

WHILYM:	begin				\     while BOOLEXP do STATEMENT
	P1:= NEWLAB;			\Labels: P1^        P2^       P3^
	CLABEL(P1);
	if SHORTBOOL then
		begin
		P2:= NEWLAB;		\true label
		P3:= NEWLAB;		\false label
		P3:= SHORTER(P2, P3);	\returns false label
		end
	else	begin
		RATOM;
		BOOLEXP;
		P3:= NEWLAB;
		GENJPC(P3,false);
		end;
	if ATOM # DOSYM then [ERROR(23); SKIPIT; return];
	RATOM;
	STATEMENT;
	GENJMP(P1);
	CLABEL(P3);
	end;

RETSYM:	begin				\'return' statement
	RATOM;
	GENDRP(STKLOD);
	if ATOM#ELSEYM & ATOM#OTHSYM & ATOM#^; & ATOM#^] &
	    ATOM#ENDSYM & ATOM#UNTSYM then	\store the returned
		[BOOLEXP;			\ value in AC or global #0
		if FACTYP=INTEGER then
			[if LEVEL=0 & ~OPTPROC then GENSTO(0, 0)
			else [TOS2AC; PDROP(1)]]
		else GENFSTO(0, 0)];
	if OPTPROC then GENRTS(LEVEL)
	else GENRET(LEVEL);
	end;

LOOPYM:	begin				\'loop' statement
	SFIXS:= FIXCNT;
	RATOM;
	P2:= NEWLAB;
	CLABEL(P2);
	SSTATEMENT(STKLOD);
	GENJMP(P2);
	while FIXCNT>SFIXS do		\fix the jumps for the 'quit's
		[FIXCNT:= FIXCNT-1; CLABEL(FIXES(FIXCNT))];
	end;

FORSYM:	begin				\'for' statement
	LOPARAMS:= RESERVE(3*2);	\optimize when limits are immediate
	HIPARAMS:= RESERVE(3*2);
	RATOM;
	if ATYPE#IDENTIFIER then [ERROR(33); SKIPIT; return];
	LOOKUP;
	if IDTYPE=UNDEF then ERROR(10)
	else if IDTYPE#INVAR & IDTYPE#ADDRVAR then ERROR(33);
	SLEV:= LEV; SVAL:= VAL;
	RATOM;
	if ATOM#GETSYM then [ERROR(21); SKIPIT; return];
	RATOM;
	BOOLEXP;
	LOPARAMS(0):= PSTKTYP(PSTKPTR-1);
	LOPARAMS(1):= PSTKLEV(PSTKPTR-1);
	LOPARAMS(2):= PSTKOFF(PSTKPTR-1);

	if FACTYP#INTEGER then ERROR(47);
	GENSTO(SLEV, SVAL);
	if ATOM#^, then [ERROR(24); SKIPIT; return];
	RATOM;
	BOOLEXP;
	HIPARAMS(0):= PSTKTYP(PSTKPTR-1);
	HIPARAMS(1):= PSTKLEV(PSTKPTR-1);
	HIPARAMS(2):= PSTKOFF(PSTKPTR-1);

	if HIPARAMS(0)#IMMTYP then
		begin
		TOS2AC;		\increment upper limit so JOZ is not needed
		TTXT("	INC|");
		TOS2STACK;
		end
	else	HIPARAMS(1):= HIPARAMS(1)+1;

	if FACTYP#INTEGER then ERROR(47);
	if ATOM#DOSYM then [ERROR(23); SKIPIT; return];

	\We don't need to JMP to FOR op if loop limits are immediate values (and
	\ low limit <= hi limit) because the loop will be executed at least once
	FLAG:= LOPARAMS(0)=IMMTYP & HIPARAMS(0)=IMMTYP & LOPARAMS(1)<HIPARAMS(1);
	if ~FLAG then
		begin
		\Make sure copy of control variable is in AC
		if SLEV#ACLEV ! SVAL#ACOFF then
			begin
			OPSTRING("	LDA	&|", ^A, SLEV, SVAL, 0);
			ACLEV:= SLEV; ACOFF:= SVAL; ACIMM:= false;
			end;
		P2:= NEWLAB;
		GENJMP(P2);
		end;
	P3:= NEWLAB;
	CLABEL(P3);

	RATOM;
	STKLOD:= STKLOD+1;
	STATEMENT;
	STKLOD:= STKLOD-1;
	GENINP(SLEV, SVAL);
	if ~FLAG then CLABEL(P2);
	GENFOR(SLEV, SVAL, P3, HIPARAMS(0), HIPARAMS(1));
	end;

EXITYM:	[RATOM;					\'exit' statement
	if ATOM#ELSEYM & ATOM#OTHSYM & ATOM#^; & ATOM#^] &
	    ATOM#ENDSYM & ATOM#UNTSYM then	\store the returned
		[BOOLEXP;			\ value in global #0
		if FACTYP=INTEGER then GENSTO(0, 0) else GENFSTO(0, 0)];
	GENEXIT];

ELSEYM, OTHSYM, ^;, ^], ENDSYM, UNTSYM:	[];

EOF:	[]				\(this is mostly an academic issue)
other	ASSIGN;
end;	\STATEMENT



begin	\SSTATEMENT
\Trick to adjust stack (with DRP's) when a 'quit' is in a 'case' statement.
STATEMENT;
end;	\SSTATEMENT

\-------------------------------------------------------------------------------

proc	PROCEDURE; int SSNOX;	\SSNO from PROCDEC for optimized procedures
int	SLEVEL,		\save level (complicated by optimized procedures)
	K, I, P1,
	HEAPSP,		\heap space requirement counter (formerly called DX)
	HEAPSPOFF,	\variable's offset from base (=HEAPSP if no arrays)
	HAVESTART,	\flag: have generated start-up code for procedure
	OLDCOD,		\OLDCODCNT to see if there is code in Main proc
	FPBASE,		\PC at end of declarations
	FPROCNT;	\count of pending forward procedures



proc	EATARGS;	\Skip arguments in parentheses
begin
if ATOM=^( then
	begin
	loop	[if CHAR=^) then quit;
		if CHAR=$0D\CR\ then [ERROR(44); quit];
		GETCH];
	GETCH; RATOM;
	end;
end;	\EATARGS



proc	CODDEC;		\Declare intrinsic names
int	SID;
begin
SID:= ININT;		\default is integer intrinsic
RATOM;
if ATOM=REALYM then [SID:= RLINT; RATOM]
else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	EATARGS;
	if ATOM#^= then ERROR(40);
	RATOM;
	GETCON; if FACTYP#INTEGER then ERROR(47);
	if IATOM<0 ! IATOM>127 then ERROR(7);
	INSERT(SID, LEVEL, IATOM);
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\CODDEC



proc	CONDEC;		\Declare constant names
int	CNTR, SSNO;
begin
RATOM;
CNTR:= 0;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	begin
	RATOM;
	if ATOM#^= then [INSERT(INCON, LEVEL, CNTR); CNTR:= CNTR+1]
	else	begin
		SSNO:= NOSYM;
		INSERT(INCON, LEVEL, NORLSY);	\insert ID now
		RATOM;				\ fix up parms later
		CONEXPRESS;
		if FACTYP=INTEGER then SYMVAL(SSNO):= IATOM
		else	[SYMTYP(SSNO):= RLCON;	\FACTYP=REAL
			if NORLSY>=RLMAX then
				[ERROR(2); NORLSY:= RLMAX-1];
			RLTBL(NORLSY):= RLATOM;
			NORLSY:= NORLSY+1];
		end;
	if ATOM=^, then RATOM;
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\CONDEC



proc	CHECKSTART;	\Generate start-up code for procedure, if not done
begin
if not HAVESTART then
	begin
	if LEVEL=0 then GENSTART;	\beware of more than 64K of 'eproc's
	HAVENEST:= true;		\assume worst case
	GENBASE(LEVEL,HEAPSP);
	HEAPSP:= 0;			\it's been reserved (don't do it again)
	OPTPROC:= false;
	HAVESTART:= true;
	end;
end;	\CHECKSTART



proc	VARDEC(TYPE);	\Declare variables--int, real & addr
int	TYPE;
int	SHEAPSP,DIMS,T,ST;
begin
RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	begin
	INSERT(TYPE,LEVEL,HEAPSPOFF);
	SHEAPSP:=HEAPSPOFF;
	HEAPSPOFF:=HEAPSPOFF +(if TYPE=RLVAR then RLSIZE else 2);
	T:=if TYPE=RLVAR then RLSIZE else 2;
	ST:= T;
	if TYPE=ADDRVAR then ST:=2\1\;	\"bytes" on the D16 are 16 bits wide
	RATOM;
	if ATOM=^( then			\get dimensions of an array
		begin
		CHECKSTART;
		if HEAPSP#0 then [GENHPI(HEAPSP); HEAPSP:=0];
		DIMS:= 0;
		loop	begin
			RATOM;
			CONEXPRESS;
			if FACTYP#INTEGER then ERROR(47);
			\Push sizes of each dimension onto stack
			GENIMM(^C,IATOM);
			TOS2STACK; PDROP(1);
			DIMS:= DIMS +1;		\count number of dimensions
			if ATOM # ^, then	\last dimension of char array is
				begin		\ only a single byte per entry
				if ST=1 then T:=T>>1;	\ST is never = 1 on D16
				T:=T*IATOM;
				HEAPSPOFF:=HEAPSPOFF+T;
				quit;
				end;
			T:=T*IATOM;    \accumulate byte count for each dimension
			HEAPSPOFF:=HEAPSPOFF+T;	\offset from base
			end;
		if ATOM#^) then ERROR(44) else RATOM;

		\gen code to set up array at run time, for example:
		\gen call MakeArray( (3, 5, 7, 11), 4, 2);
		GENIMM(^C,DIMS);	\number of dimensions (4)
		TOS2STACK; PDROP(1);
		GENIMM(^C,ST);		\number of bytes in each element (2)
		TOS2AC; PDROP(1);
		GENARY;
		end
	else	HEAPSP:= HEAPSP + (if TYPE=RLVAR then RLSIZE else 2);
	if ATOM=^, then RATOM;
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\VARDEC



proc	SEGDEC;		\Declare segment variables
begin
RATOM;
case ATOM of
	INTSYM: VARDEC(INSEG);
	REALYM: VARDEC(RLSEG);
	ADRSYM, CHARYM: VARDEC(ADSEG);
	SHTSYM: VARDEC(SHSEG)
else ERROR(72);
end;	\SEGDEC



proc	EXTDEC(XPL);	\Declare external procedures
int	XPL;		\flag: XPL-type external (eproc) vs. assembly (ext)
int	SID, D;
begin
ERROR(0);		\unsupported feature
\Handle XPL vs. assembly type external. The default is integer external.
SID:= if XPL then INEPRO else INEXT;

RATOM;					\handle real vs. integer procedure
if ATOM=REALYM then [SID:= if XPL then RLEPRO else RLEXT; RATOM]
else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);

D:= 0;
while ATYPE=IDENTIFIER do
	begin
	INSERT(SID, LEVEL, IATOM);
	RATOM;
	EATARGS;
	if ATOM=^, then RATOM;
	TTXT("	EXTRN	");
	if XPL then CHOUT(BINDEV, ^_); 
	SYMOUT(NOSYM-1);
	if ~XPL then TTXT(":FAR")  	\assembly externals are always "far"
	else TTXT(":NEAR");
	D:= D+1;
	CRLF(BINDEV);
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\EXTDEC



proc	FPRDEC;		\Declare forward-referenced procedures
int	SID, I;
begin
SID:= INFPROC;		\default type
RATOM;
if ATOM=REALYM then [SID:= RLFPROC; RATOM]
else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	begin
	RATOM;
	I:= NEWLAB;
	INSERT(SID, LEVEL, I);
	FLABEL(I);
	GENFJMP(NEWLAB);
	FPROCNT:= FPROCNT+1;
	EATARGS;
	if ATOM=^, then RATOM;
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\FPRDEC



proc	PROCDEC(CANOPT, PUBLIC);	\Declare procedure names
int	CANOPT, PUBLIC;
int	SNOSYM, HASH, I, K, SID, SSNO, SNORL;
begin
SID:= INPROC;				\typed procedure (for functions)
RATOM;
if ATOM=REALYM then [SID:= RLPROC; RATOM]
else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45) else LOOKUP;

if IDTYPE=INFPROC ! IDTYPE=RLFPROC then
	\Procedure has been previously declared by a 'fproc' or 'ffunct'
	begin
	if LEVEL#LEV then ERROR(65);	\('fproc' & 'proc' must be same scope)
	if PUBLIC then			\handle public procedures
		begin
		TTXT("	PUBLIC	_");
		SYMOUT(SYMNUM);
		TTXT("|_");
		SYMOUT(SYMNUM);
		TTXT(":|");
		end;
	FLABEL(VAL+1);
	SYMVAL(SYMNUM):= VAL+1;
	SYMTYP(SYMNUM):= if IDTYPE=INFPROC then INPROC else RLPROC;
	if SID#SYMTYP(SYMNUM) then \mixed mode\ ERROR(46);
	if VAL>=FPBASE then FPROCNT:= FPROCNT-1;
	OPTPROC:= false;
	end
else	begin
	SSNO:= NOSYM;
	I:= NEWLAB;
	INSERT(SID, LEVEL, I);
	if PUBLIC then			\handle public procedures
		begin
		TTXT("	PUBLIC	_");
		SYMOUT(NOSYM-1);
		TTXT("|_");
		SYMOUT(NOSYM-1);
		TTXT(":|");
		end;
	FLABEL(I);
	OPTPROC:= CANOPT;
	end;

\Assume for now that procedure is not optimized and move down a level
SLEVEL:=LEVEL;
LEVEL:= LEVEL+2; if LEVEL >= LEVELMAX*2 then ERROR(5);
\Eat the argument list as a comment. This special comment stops on CR.
while CHAR#^; & CHAR#\CR\$0D do GETCH;
if CHAR#^; then ERROR(41);
GETCH; RATOM;

SNOSYM:= NOSYM; SNORL:= NORLSY;
PROCEDURE(SSNO);	\pass location of proc name in case it's optimized
if ATOM#^; then ERROR(41) else RATOM;
while NOSYM>SNOSYM do	\restore symbol table to previous level
	begin		\i.e. remove identifiers which were local to this procedure
	NOSYM:= NOSYM-1;
	HASH:= 0; K:= NOSYM;
	for I:= 0, SIGCHAR-1 do
		[HASH:= HASH+SYMBOL(K); K:= K+SYMAX];
	BOX(HASH&HASHMSK):= SYMPNT(NOSYM);
	end;
NORLSY:= SNORL;
LEVEL:= SLEVEL;
HAVENEST:= true;
end;	\PROCDEC



begin	\PROCEDURE
ACLEV:= -1;
ACIMM:= false;
OLDLEV:= -1;
HAVENEST:= false;

HEAPSPOFF:= if LEVEL=0 then RLSIZE else 0;	\save heap space for 'return'
HEAPSP:= HEAPSPOFF;
HAVESTART:= false;

loop	begin
	case ATOM of
	  INTSYM: VARDEC(INVAR);
	  ADRSYM: VARDEC(ADDRVAR);
	  CHARYM: VARDEC(ADDRVAR);
	  REALYM: VARDEC(RLVAR);
	  SEGSYM: SEGDEC;
	  CODSYM: CODDEC;
	  EXTNYM: EXTDEC(false);
	  DEFSYM: CONDEC;
	  EPRSYM, EFUNYM:
		  if LEVEL=0 then EXTDEC(true) else [ERROR(68); SKIPIT]
	other	quit;
	end;

if not HAVESTART then
	if LEVEL=0 then GENSTART;	\beware of more than 64K of 'eproc's

\Process lower level procedures...
case ATOM of
  PUBSYM, PROCYM, FUNSYM, FPRSYM, FFUNYM:
	begin
	P1:= NEWLAB;
	GENJMP(P1);
	end
other P1:= 0 \null\;

FPROCNT:= 0;
FPBASE:= LABCNT;
loop	begin
	case ATOM of
	  PUBSYM:
		[if LEVEL#0 then ERROR(68);
		RATOM;
		case ATOM of PROCYM, FUNSYM: PROCDEC(false, true)
		other ERROR(67)];
	  PROCYM, FUNSYM:
		PROCDEC(true, false);
	  FPRSYM, FFUNYM:
		FPRDEC			\'fproc' cannot precede a 'def'
	other	quit;
	end;

if P1#0 then CLABEL(P1);

if HEAPSPOFF#0 then OPTPROC:=false;
if OPTPROC then
	begin
	SYMTYP(SSNOX):= if SYMTYP(SSNOX)=INPROC then INOPT else RLOPT;
	LEVEL:=LEVEL-2;	\same level as nesting procedure (tricky!)
	OPTNEWLEVEL(LEVEL);
	end
else	begin		\reserve space for local variables (if not already done)
	if not HAVESTART then GENBASE(LEVEL,HEAPSP)
	else GENHPI(HEAPSP);
	end;

OLDCOD:= CODCTR;			\is there code in the Main procedure?
SSTATEMENT(STKLOD);			\(STKLOD will always be zero here)
HASMAIN:= CODCTR # OLDCOD;

if OPTPROC then GENRTS(LEVEL) else GENRET(LEVEL);

if FIXCNT#0 then \some 'quit's not in a 'loop'\ ERROR(60);
if FPROCNT#0 then \unresolved fwd references\ ERROR(66);
end;	\PROCEDURE

\------------------------ ROUTINES TO OPEN DOS FILES ---------------------------

proc	DOSOPEN;
int	CPUREG, PSPSEG, DATASEG, T;
char	CMDTAIL;

	func	GETSWT;		\Find, remove and return a switch
	int	P, T;
	begin
	for P:= 1, CMDTAIL(0) do
	    if CMDTAIL(P)=^/ then
		begin
		CMDTAIL(P):= $20;
		if P < CMDTAIL(0) then
			begin
			T:= CMDTAIL(P+1);
			if T>=^a & T<=^z then T:= T-$20; \make uppercase
			CMDTAIL(P+1):= $20;
			return T;
			end;
		end;
	return 0;
	end;	\GETSWT


	proc	PARSE;		\Parse command tail and set I/O handles
	char	EXTIN, EXTOUT;
	int	P, P0, EXTFLG, I;
	begin
	EXTIN:= ".XPL";   EXTOUT:= ".ASM";
	P:= 1;
	EXTFLG:= false;
	loop	begin			\parse command tail for extension
		if CMDTAIL(P) = ^. then
			begin
			EXTFLG:= true;
			quit;
			end;
		if CMDTAIL(P) = ^; then quit;	\ignore semicolon
		if P > CMDTAIL(0) then quit;	\if quit then P points to CR
		P:= P + 1;
		end;

	\Back up over any trailing spaces (caused by switches)
	repeat P:= P - 1 until CMDTAIL(P) # ^ ;
	P:= P + 1;

	if not EXTFLG then			\set extension and input handle
		for I:= 0, 3 do CMDTAIL(P+I):= EXTIN(I);
	INHAND:= FOPEN(CMDTAIL+1, 0);

	for I:= 0, 3 do CMDTAIL(P+I):= EXTOUT(I); \set extension & output handle
	OUTHAND:= FOPEN(CMDTAIL+1, 1);

	\Copy file name into FNAME
	P0:= P - 1;			\P0 points to last character in file name
	repeat	P:= P - 1;
	until	CMDTAIL(P)=^  ! CMDTAIL(P)=^\ ! CMDTAIL(P)=^:;

	P:= P + 1;			\point to first character of file name
	for I:= 0, 7 do
		begin
		FNAME(I):= CMDTAIL(P+I);
		if P+I=P0 ! I=7 then
			begin
			FNAME(I):= FNAME(I) ! $80;
			I:= 7;
			end;
		end;
	end;	\PARSE


begin	\DOSOPEN
CMDTAIL:= RESERVE($80+4);		\get command tail from PSP
CPUREG:= GETREG;
PSPSEG:= CPUREG(11);
DATASEG:= CPUREG(12);
BLIT(PSPSEG, $80, DATASEG, CMDTAIL, $80);

loop	begin				\handle switches
	T:= GETSWT;
	case T of
	  ^B:	SHORTBOOL:= true;	\short-circuit boolean evaluation
	  ^D:	DEBUG:= true;		\list source code in output file
	  ^L:	LSTDEV:= 0;		\list source code on monitor screen
	  ^C:	COMFLG:= true;		\include I2L comments in output file
	  ^A:	[BINDEV:= 0; LSTDEV:= 7]; \list assembly code to monitor screen
	   0:	quit			\no more switches on command line
	other	[TEXT(TV,"UNRECOGNIZED SWITCH: /"); CHOUT(TV, T); CRLF(TV); exit 1];
	end;
PARSE;					\parse command line and set file handles
FSET(INHAND, ^I);
FSET(OUTHAND, ^O);
end;	\DOSOPEN

\-------------------------------------------------------------------------------

begin	\Main
IDENT:= RESERVE(SIGCHAR);
PROCRETS:= RESERVE(LEVELMAX*2);
FIXES:= RESERVE(2*QUITMAX);
SYMBOL:= RESERVE(SIGCHAR*SYMAX);	\symbol table
SYMTYP:= RESERVE(SYMAX);
SYMVAL:= RESERVE(SYMAX*2);
SYMLEV:= RESERVE(SYMAX);
SYMPNT:= RESERVE(SYMAX*2);
BOX:= RESERVE(BOXNUM*2);		\hash table
RLTBL:= RLRES(RLMAX);
HEXDIGIT:= "0123456789ABCDEF ";

PSTKTYP:= RESERVE(STKMAX*2);		\pseudo stack (for optimizing)
PSTKLEV:= RESERVE(STKMAX*2);
PSTKOFF:= RESERVE(STKMAX*2);

FNAME:= RESERVE(8);
OLDHAN:= RESERVE(HANMAX*2);		\set 'include' arrays

TEXT(TV,"
-- XPL0 OPTIMIZING COMPILER FOR D16/M, VER O2.4.7 --
            COPYRIGHT 2005 P.J.R. BOYLE

XPL0 comes with ABSOLUTELY NO WARRANTY.
This is free software. You are welcome and encouraged to redistribute
it under certain conditions. For details see LICENSE.TXT.

");
SHORTBOOL:= false;
DEBUG:= false;
COMFLG:= false;
BINDEV:= 3; LSTDEV:= 8; SRCDEV:= 3;
DOSOPEN;
OPENO(BINDEV); OPENO(LSTDEV); OPENI(SRCDEV);

LABCNT:= 0; LEVEL:= 0;			\initialize some stuff...
for II:= 0, LEVELMAX-1 do PROCRETS(II):= 0;
STKLOD:= 0; NOSYM:= 0; NORLSY:= 0; FIXCNT:= 0;
for II:= 0, BOXNUM do BOX(II):= EMTPNT;	\zero the symbol table
ERRCNT:= 0;
LASTOP:= -1;	\null
PSTKPTR:= 0; HANPTR:= 0;
LOCAL:= 0;
OLDLEV:= -1;
CODCTR:= 0;
OLDCODCTR:= CODCTR;
CONDITIONAL:= true;

GETCH; RATOM;
OPTPROC:= false;			\(for two reasons)
PROCEDURE(0);				\compile Main procedure, i.e. the program
while ATOM=^; do RATOM;
if ATOM#EOF then \more code after end\ [ERROR(61); PROCEDURE(0)];

\if program has a 'Main', make it public
\if HASMAIN then TTXT("	PUBLIC	PROGRM|");
GENEND;

CHOUT(BINDEV, EOF);
CLOSE(BINDEV);

CRLF(LSTDEV);
TEXT(LSTDEV, "ERRORS DETECTED: "); INTOUT(LSTDEV, ERRCNT); CRLF(LSTDEV);
CLOSE(LSTDEV);
CRLF(TV);

FCLOSE(OUTHAND);
FCLOSE(INHAND);
return if ERRCNT#0 then 1 else 0;
end;	\Main
