\ DR. ELIZA.XPLV4		1/18/81
\ BY LOREN BLANEY & RICHARD OTTOSEN
\ ORIGINAL BY JOSEPH WEIZENBAUM.  REF: ACM COMM JAN 66.

code	RESERVE=3, SWAP=4,
	CHIN=7, CHOUT=8, CRLF=9, INTIN=10, INTOUT=11,
	TEXT=12, OPENI=13, OPENO=14, CLOSE=15;
def	TV=0, KB=0, PR=7\NULL\, EOT=\KB BUFFER TERMINATOR (=CR)\$0D;
def	INTSIZE=1;

int	KEY,	\KEY WORD--INDEX INTO KEYTBL
	REP,	\INDEX INTO REPLY TABLE
	CNJ,	\INDEX INTO CONJUGATION TABLE
	REPGRP,	\REPLY GROUP--INDEX INTO RXTBL
	KEYS, REPS, CNJS, REPGPS,  \TOTAL NUMBER OF ENTRIES
	LEN,	\LENGTH OF INPUT LINE
	KEYPTR,	\POINTER TO KEY WORD IN LINE
	EQUAL,	\BOOLEAN--STRINGS ARE EQUAL
	CMPCTR,	\NO. OF CHARS (-1) IN COMPARED STRING
	MEMPTR;	\MEMORY POINTER FOR REMEMBERING PHRASES

int	\INTEGER ARRAYS:
	KEYTBL,	\ENTRIES POINT TO KEY WORD STRINGS
	REPTBL,	\ENTRIES POINT TO REPLY STRINGS
	CNJTBL,	\POINTERS TO CONJUGATION STRINGS
	MEMTBL,	\POINTERS TO MEMORY REPLIES
	MEMTB3;	\POINTERS TO APPENDED TEXT IN ABOVE

addr	A,	\SCRATCH
	LINE,	\PATIENT'S INPUT LINE
	RTBL,	\ARRAY--ENTRIES POINT TO ENTRIES IN RXTBL
	RXTBL,	\ARRAY--ENTRIES POINT TO ENTRIES IN REPTBL
	SXTBL,	\ARRAY--POINTERS TO START OF REPLY GROUPS
	LINECJ,	\CONJUGATED LINE
	MEMTB5;	\ARRAY--INDICIES TO REPLY TABLE


proc	SETUP;		\SETUP TABLES
addr	MEM0, MEM1, MEM2;

proc	K(A);		\SETUP KEYWORD TABLE
addr	A;
[KEYTBL(KEY):=A; RTBL(KEY):=REPGRP; KEY:=KEY+1];


proc	R(A);		\SETUP REPLY TABLE
addr	A;
[REPTBL(REP):=A; REP:=REP+1];


proc	N;	\SETUP REPLY GROUP TABLE--NEXT REPLY GROUP
[RXTBL(REPGRP):=REP; SXTBL(REPGRP):=REP; REPGRP:=REPGRP+1];


proc	C(A);		\SETUP CONJUGATION TABLE
addr	A;
[CNJTBL(CNJ):=A; CNJ:=CNJ+1];


begin	\SETUP
KEY:=0; REP:=0; REPGRP:=0; CNJ:=0;
\IF THIS SCRIPT IS CHANGED THE FOLLOWING MAY ALSO NEED CHANGING:
\MEMORY REPLY INDICIES IN MEMTB5; IN MAIN PROC:  KEYS, REPS,
\REPGPS, AND THE KEY INDICIES OF "BYE", "MY" & "HI".
\NOTE THAT KEY WORDS ARE IN ORDER OF IMPORTANCE.  ALSO
\ WORDS ARE COMPARED FROM THE FIRST LETTER, SO THE KEYWORD
\ "DAY" WILL NOT MATCH "SUNDAY" BUT WILL MATCH "DAYS" (KEYWORDS
\MAY NOT START WITH A SPACE CHAR).
\THERE IS A DEFINITE ART TO WRITTING SCRIPTS, SO THAT SEEMINGLY
\ SUBTLE CHANGES CAN CAUSE SIGNIFICANT DIFFERENCES.

K("HELLO"); K("HI "); K("HI."); K("HI!"); K("HI,"); N;
R("HOW DO YOU DO.  PLEASE TELL ME ABOUT YOUR PROBLEMS.");

K("BYE");	\(RESPONSE IS TO TERMINATE CONVERSATION)

K("COMPUTER"); K("MACHINE"); N;
R("WHY DO YOU MENTION COMPUTERS?");
R("ARE YOU TALKING ABOUT ME IN PARTICULAR?");
R("ARE YOU INTIMIDATED BY MACHINES?");
R("WHAT DO YOU THINK MACHINES HAVE TO DO WITH YOUR PROBLEM?");
R("DON^'T YOU THINK COMPUTERS CAN HELP PEOPLE?");
R("WHAT IS IT ABOUT MACHINES THAT WORRIES YOU?");

K("ALIKE"); K("SAME"); N;
R("IN WHAT WAY?");
R("WHAT DOES THE SIMILARITY SUGGEST TO YOU?");
R("WHAT RESEMBLANCE DO YOU SEE?");
R("WHAT OTHER CONNECTIONS DO YOU SEE?");

K("FRIEND"); N;
R("DO YOUR FRIENDS WORRY YOU?");
R("DO YOUR FRIENDS PICK ON YOU?");
R("ARE YOU SURE YOU HAVE ANY FRIENDS?");
R("WHAT ABOUT OTHER PEOPLE?");
R("DO YOU IMPOSE ON YOUR FRIENDS?");
R("PERHAPS YOUR LOVE FOR FRIENDS WORRIES YOU?");

K("EVERYONE"); K("EVERYBODY"); K("NOBODY"); K("MEN ");
K("NO ONE"); K("NO-ONE"); K("PEOPLE"); K("WOMEN"); N;
R("CAN YOU THINK OF ANYONE IN PARTICULAR?");
R("WHO, FOR EXAMPLE?");
R("ARE YOU THINKING OF A VERY SPECIAL PERSON?");
R("YOU HAVE A PARTICULAR PERSON IN MIND DON^'T YOU?");

K("SOMETIMES"); K("OCCASION"); N;
R("WHEN FOR EXAMPLE?");
R("CAN YOU TELL ME ABOUT A RECENT INSTANCE?");
R("HOW ABOUT NOW?");

K("ALWAYS"); N;
R("WHEN FOR INSTANCE?");
R("REALLY, ALWAYS?");
R("CAN YOU THINK OF A SPECIFIC EXAMPLE?");
R("WHAT SPECIFICALLY ARE YOU THINKING OF?");

K("CANT "); K("DONT "); K("IM "); K("YOURE "); K("IVE "); N;
R("PLEASE USE APOSTROPHES."); 
R("I TOLD YOU TO USE APOSTROPHES.");

K("WHY CAN^'T I "); N;
R("DO YOU THINK YOU SHOULD BE ABLE TO *?");
R("HAVE YOU REALLY TRIED TO *?");

K("CAN I "); K("CAN^'T I "); N;
R("PERHAPS YOU DON^'T WANT TO *.");
R("DO YOU WANT TO BE ABLE TO *?");

K("I FEEL"); K("I JUST FEEL"); K("I FELT"); N;
R("TELL ME MORE ABOUT SUCH FEELINGS.");
R("DO YOU OFTEN FEEL*?");
R("DO YOU ENJOY FEELING*?");
R("WHAT DOES FEELING* REMIND YOU OF?");

K("I CAN^'T"); K("I CANNOT"); K("I JUST CAN^'T"); N;
R("HOW DO YOU KNOW YOU CAN^'T*?");
R("HAVE YOU TRIED?");
R("PERHAPS YOU COULD* NOW.");

K("I AM "); K("I^'M "); N;
R("IS IT BECAUSE YOU ARE * THAT YOU CAME TO ME?");
R("HOW LONG HAVE YOU BEEN *?");
R("DO YOU THINK IT^'S ABNORMAL TO BE *?");

K("I HAVE "); K("I^'VE "); K("I JUST HAVE "); N;
R("DOES HAVING * REALLY TROUBLE YOU?");
R("DO YOU FEEL IT IS UNUSUAL TO HAVE *?");
R("WHAT DOES HAVING * MEAN TO YOU?");
R("DO YOU THINK TALKING TO ME WILL HELP YOU NOT TO HAVE *?");
R("PERHAPS YOU ENJOY HAVING *.");
R("DO YOU THINK YOU SHOULD NOT HAVE *?");
R("DOES HAVING * REMIND YOU OF ANYTHING ELSE?");

K("I WANT "); K("I NEED "); K("I JUST WANT "); K("I^'D LIKE ");
K("I^'D JUST LIKE "); K("I WOULD LIKE "); K("I JUST NEED "); N;
R("WHAT WOULD GETTING * MEAN TO YOU?");
R("WHY DO YOU WANT *?");
R("SUPPOSE YOU GOT * SOON.");
R("I SOMETIMES ALSO WANT *.");

K("I THINK "); K("I BELIEVE "); K("I THOUGHT ");
K("I DON^'T THINK "); K("I DON^'T BELIEVE "); N;
R("DO YOU REALLY THINK SO?");
R("BUT YOU ARE NOT SURE *?");
R("DO YOU DOUBT *?");

K("I DON^'T "); K("I JUST DON^'T "); K("I DO NOT ");
K("I REALLY DON^'T "); N;
R("WHY DON^'T YOU *?");
R("DO YOU WISH TO BE ABLE TO *?");
R("DOES THAT TROUBLE YOU?");
R("DON^'T YOU REALLY *?");

K("I DIDN^'T "); K("I DID NOT "); N;
R("WHY DIDN^'T YOU *?");
R("DID YOU WISH TO BE ABLE TO *?");
R("DID THAT BOTHER YOU?");
R("DID^'T YOU REALLY *?");

K("MY "); N;
R("WHY DO YOU SAY YOUR *?");
R("DOES THAT REMIND YOU OF ANYTHING ELSE OF YOURS?");
R("YOUR *?");

K("SORRY"); N;
R("PLEASE DON^'T APOLOGIZE!");
R("I^'VE TOLD YOU APOLOGIES AREN^'T NECESSARY.");
R("WHAT FEELINGS DO YOU HAVE WHEN YOU APOLOGIZE?");
R("DON^'T BE SO DEFENSIVE!");

K("BECAUSE"); N;
R("DOES ANY OTHER REASON COME TO MIND?");
R("DO YOU THINK THAT* IS THE REAL REASON?");
R("DOES THAT REASON EXPLAIN ANYTHING ELSE?");
R("CAN YOU THINK OF ANY OTHER REASON THAN*?");
R("WHAT OTHER REASONS MIGHT THERE BE?");
R("COULD THERE BE SOME OTHER EXPLAINATION?");

K("DREAM"); N;
R("WHAT DOES THAT SUGGEST TO YOU?");
R("WHAT PERSONS APPEAR IN YOUR DREAMS?");
R("DO YOU DREAM OFTEN?");
R("ARE YOU DISTURBED BY YOUR DREAMS?");

K("WHAT TIME"); N;
R("WHY ARE YOU CONCERNED ABOUT THE TIME?");

K("TIME"); K("YEAR"); K("DAY"); K("MONTH"); K("WEEK"); N;
R("WHEN EXACTLY?");
R("WILL THAT CHANGE?");
R("WHAT ABOUT OTHER TIMES?");
R("DO YOU WANT THINGS TO CHANGE?");
R("ARE THERE OTHER TIMES?");

K("WHAT"); K("HOW"); K("WHO");
K("WHERE"); K("WHY"); N;
R("WHAT IS IT THAT YOU REALLY WANT TO KNOW?");
R("WHAT DO YOU THINK?");
R("WHY DO YOU ASK?");
R("DOES THAT QUESTION INTEREST YOU?");
R("WHAT ANSWER WOULD PLEASE YOU THE MOST?");
R("ARE SUCH QUESTIONS ON YOUR MIND OFTEN?");
R("HAVE YOU ASKED ANYONE ELSE?");
R("HAVE YOU ASKED SUCH QUESTIONS BEFORE?");
R("WHAT ELSE COMES TO MIND WHEN YOU ASK THAT?");

K("CAN YOU "); K("CAN^'T YOU "); N;
R("YOU BELIEVE THAT I CAN * DON^'T YOU.");
R("PERHAPS YOU WOULD LIKE TO BE ABLE TO *.");
R("YOU WANT ME TO BE ABLE TO *?");

K("YOU ARE "); K("YOU^'RE "); N;
R("WHAT MAKES YOU THINK I AM *?");
R("DOES IT PLEASE YOU TO BELIEVE I AM *?");
R("PERHAPS YOU WOULD LIKE TO BE *.");
R("DO YOU SOMETIMES WISH YOU WERE *?");

K("DON^'T YOU "); K("DO YOU "); N;
R("DO YOU REALLY BELIEVE I DON^'T *?");
R("PERHAPS I WILL * IN GOOD TIME.");
R("DO YOU WANT ME TO *?");

K("ARE YOU "); N;
R("WHY ARE YOU INTERESTED IN WHETHER OR NOT I AM *?");
R("WOULD YOU PREFER IF I WERE NOT *?");
R("PERHAPS I^'M * IN YOUR DREAMS.");

K("YOUR "); N;
R("WHAT ABOUT YOUR OWN *?");
R("REALLY, MY *?");
R("MY * CONCERNS YOU?");

K("MAYBE"); K("MIGHT"); K("PERHAPS"); K("PROBAB"); N;
R("YOU DON^'T SEEM QUITE CERTAIN.");
R("WHY THE UNCERTAIN TONE?");
R("COULD YOU BE MORE DEFINITE?");
R("YOU AREN^'T SURE?");
R("DON^'T YOU KNOW?");

K("THANK YOU"); N;
R("YOU^'RE WELCOME!");

K("YOU "); N;
R("I^'M INTERESTED IN DISCUSSING YOUR PROBLEMS.");
R("YOU^'RE NOT REALLY TALKING ABOUT ME, ARE YOU?");
R("DO COMPUTERS WORRY YOU?");
R("ARE YOU COMPARING US IN SOME WAY?");
R("WHAT ABOUT YOUR FRIENDS?");
R("WE WERE DISCUSSING YOU, NOT ME.");
R("WHY DO YOU KEEP TALKING ABOUT ME?");

K("NO "); K("NOPE "); K("NO,"); N;
R("WHY NOT?");
R("WHY DO YOU SAY NO?");
R("NO?");
R("WHY ARE YOU SO SURE?");
R("COULD YOU EXPLAIN WHY NOT?");
R("DOES THIS QUESTION BOTHER YOU?");
R("I DON^'T MEAN TO BE IRRITATING, BUT WHY NOT?");
R("IT WILL HELP ME TO ANALYZE YOUR PROBLEMS IF YOU^'RE MORE RESPONSIVE.");
R("PERHAPS YOU WOULD LIKE TO ASK THE QUESTIONS.");
R("COULD YOU VIEW THIS IN A MORE POSITIVE WAY?");

K("YES "); K("YEP "); K("YEAH "); K("YES,"); N;
R("WOULD YOU ELABORATE?");
R("WHY DO YOU THINK SO?");
R("I SEE.  PLEASE CONTINUE.");
R("COULD YOU EXPLAIN THAT IN MORE DETAIL?");
R("YOU SEEM QUITE POSITIVE.");
R("ARE YOU ABSOLUTELY SURE?");
R("YOU DON^'T SEEM 100 PERCENT CERTAIN.");

K("NOKEYFOUND"); N;
R("WHAT DOES THAT SUGGEST TO YOU?");
R("DO YOU HAVE OTHER PSYCHOLOGICAL PROBLEMS?");
R("THAT IS INTERESTING.  PLEASE GO ON.");
R("WHAT ABOUT EMOTIONAL DIFFICULTIES?");
R("COULD YOU RESTATE THAT?");			\MEM 0
R("IS THERE ANYTHING ELSE YOU WOULD LIKE TO TALK ABOUT?");
R("WHAT EXACTLY DO YOU MEAN?");
R("PERHAPS YOU SAY THAT FOR SOME OTHER REASON?");
R("COME COME NOW, ELUCIDATE YOUR THOUGHTS.");
R("IN OTHER WORDS?");
R("I^'M NOT SURE I UNDERSTAND YOU FULLY.");	\MEM 1
R("WOULD YOU RELATE THIS TO YOUR DREAMS?");
R("CAN YOU ELABORATE ON THAT?");
R("HOW ARE YOUR PERSONAL RELATIONSHIPS?");
R("COULD YOU STATE THAT DIFFERENTLY?");		\MEM 2

K("&{z"); N;	\DUMMY FOR END OF ABOVE REPLIES


\MEMORY
MEMPTR:=0;
MEM0:="EARLIER YOU MENTIONED YOUR <-------------------------
--- (SPACE TO INSERT CONJUGATED LINE)------------->";
MEM1:="WHAT ABOUT YOUR <-------------------------
--- (SPACE TO INSERT CONJUGATED LINE)------------->";
MEM2:="EXACTLY WHY DID YOU MENTION YOUR <-------------------
--------- (SPACE TO INSERT CONJUGATED LINE)------------->";

MEMTBL(0):=MEM0; MEMTBL(1):=MEM1; MEMTBL(2):=MEM2;
\ POINTER TO APPENDED TEXT
MEMTB3(0):=MEM0+27; MEMTB3(1):=MEM1+16; MEMTB3(2):=MEM2+33;
\ REPLY TABLE INDICIES FOR ENTRY TO BE REPLACED BY MEMORY LINE
MEMTB5(0):=148; MEMTB5(1):=154; MEMTB5(2):=158;


\CONJUGATION TABLE: FIRST ENTRY IS "CONJUGATED" TO SECOND
C("YOU ARE "); C("I AM ");
C("ARE YOU "); C("AM I ");
C("YOU WERE "); C("I WAS ");
C("WERE YOU "); C("WAS I ");
C("I WAS "); C("YOU WERE ");
C("WAS I "); C("WERE YOU ");

C("I^'M "); C("YOU^'RE ");
C("YOU^'RE "); C("I^'M ");
C("AM "); C("ARE ");
C("YOU "); C("I ");	\PERHAPS YOU --> ME IS BETTER
C("ME "); C("YOU ");
C("I^'VE "); C("YOU^'VE ");
C("YOU^'VE "); C("I^'VE ");
C("MINE "); C("YOURS ");
C("YOURS "); C("MINE ");
C("MYSELF"); C("YOURSELF");
C("YOURSELF"); C("MYSELF");
C("MY "); C("YOUR ");
C("YOUR "); C("MY ");
C("I "); C("YOU ");
end;	\SETUP


proc	COMPARE(A,B);		\STRING COMPARE
\STRING "A" IS TERMINATED WITH MSB (BIT 7) SET ON LAST CHAR
\OUTPUTS: "EQUAL" BOOLEAN; CMPCTR = NO. OF CHARACTERS -1
addr	A,B;
begin
CMPCTR:=0;
loop	begin
	if (A(CMPCTR)&127) # B(CMPCTR) then
		[EQUAL:=false; return];
	if A(CMPCTR) \MSB SET\ >=128 then [EQUAL:=true; return];
	CMPCTR:=CMPCTR+1;
	end;
end;


proc	INPUT;  \GET PATIENT'S STATEMENT INTO "LINE" BUFFER
\OUTPUTS: LINE, LEN
int	I, CHAR;
begin
OPENI(KB); LEN:=0;
loop	[CHAR:=CHIN(KB);
	if CHAR =EOT then quit;
	LINE(LEN):=CHAR;
	LEN:=LEN+1];
LINE(LEN):= ^ ;			\ADD A SPACE CHAR
LINE(LEN +1):= ^ !128;		\END LINE WITH A SPACE CHAR
TEXT(PR,LINE); CRLF(PR);	\WRITE TRANSCRIPT

for I:=0,LEN do 		\CONVERT "LINE" TO UPPER CASE
	if LINE(I) >=^a & LINE(I) <=^z then
		LINE(I):= LINE(I)&(not 32);
end;


proc	SCAN;		\SCAN LINE FOR A KEY WORD
\OUTPUTS: KEY, KEYPTR, EQUAL, CMPCTR
addr	A;
begin
KEY:=0;
loop	begin
	if KEY = \NOKEYFOUND\ KEYS-2 then quit;
	KEYPTR:=0;
	A:=KEYTBL(KEY);
	loop	begin
		if KEYPTR > LEN then quit;
		COMPARE(A, LINE+KEYPTR);
		if EQUAL then return;
		KEYPTR:=KEYPTR+1;
		while LINE(KEYPTR)# ^  do KEYPTR:=KEYPTR+1;
		\(THIS CAN HANG IN A LOOP IF LINE IS JUST A CR)
		while LINE(KEYPTR)= ^  do KEYPTR:=KEYPTR+1;
		end;
	KEY:=KEY+1;
	end;
end;


proc	CONJUGATE;	\(SUBSTITUTE "AM" FOR "ARE" ETC.)
\INPUTS: LINE, KEYPTR, CMPCTR, CNJTBL
\OUTPUTS: LINECJ
int	LINPTR,	\"LINE" POINTER
	I, J,
	CNJPTR;	\CONJUGATED LINE POINTER
addr	A, LINEX;

begin
LINPTR:=KEYPTR +CMPCTR +1;  \LINPTR POINTS JUST BEYOND KEY WORD
LINEX:=RESERVE(65);
I:=0;
\MOVE LINE INTO LINEX; STOP ON PUNCTUATION & CONJUNCTIONS.
loop	begin
	J:=LINE(LINPTR);
	if J= ^, ! J= ^. ! J= ^? ! J= ^! ! J= ^;!
		J= ^: ! J= ^( ! J= ^) ! J= ^& then quit;
	COMPARE(" AND ",LINE+LINPTR); if EQUAL then quit;
	COMPARE(" OR ",LINE+LINPTR); if EQUAL then quit;
	COMPARE(" BUT ",LINE+LINPTR); if EQUAL then quit;
	COMPARE("--",LINE+LINPTR); if EQUAL then quit;
	COMPARE(" THEREFORE",LINE+LINPTR); if EQUAL then quit;
	COMPARE(" HOWEVER",LINE+LINPTR); if EQUAL then quit;
	COMPARE(" ELSE ",LINE+LINPTR); if EQUAL then quit;
	LINEX(I):=J;
	I:=I+1;
	if J = \LAST CHAR\(^ !128) then quit;
	LINPTR:=LINPTR+1;
	end;
LINEX(I):= ^ ; LINEX(I+1):= ^ !128;

LINPTR:=0; CNJPTR:=0;
loop	begin
	if LINEX(LINPTR) = (^ !128) then
		[LINECJ(CNJPTR):=LINEX(LINPTR); quit];
	CNJ:=0;
	loop	begin		\SCAN CONJUGATION TABLE
		if CNJ > CNJS-1 then [EQUAL:=false; quit];
		COMPARE(CNJTBL(CNJ), LINEX+LINPTR);
		if EQUAL then quit;
		CNJ:=CNJ+2;
		end;
	if EQUAL then		\MAKE SUBSTITUTION
		begin
		LINPTR:=LINPTR+CMPCTR+1;  \SKIP WORD IN LINEX
		A:=CNJTBL(CNJ+1);
		J:=0;
		loop	[LINECJ(CNJPTR):=A(J)&127;
			CNJPTR:=CNJPTR+1;
			if A(J)>=128 then quit;
			J:=J+1];
		end
	else	begin
		loop	[LINECJ(CNJPTR):=LINEX(LINPTR);
			if LINECJ(CNJPTR)= ^  then quit;
			CNJPTR:=CNJPTR+1;
			LINPTR:=LINPTR+1];
		CNJPTR:=CNJPTR+1;
		LINPTR:=LINPTR+1;
		end;
	end;
end;	\CONJUGATE


proc	REPLY;		\OUTPUT ELIZA'S REPLY
\INPUTS: KEY, LINECJ
int	X, Y;
addr	RT;		\POINTER TO REPLY STRING IN REPTBL
begin
\LOOK UP REPLY FOR GIVEN KEY WORD
X:=RTBL(KEY);	\X IS INDEX INTO RXTBL
Y:=RXTBL(X);	\Y IS INDEX INTO REPTBL
RXTBL(X):=Y+1;
\BUMP REPLY TABLE POINTER
if RXTBL(X) >= SXTBL(X+1) then RXTBL(X):=SXTBL(X);

RT:=REPTBL(Y);
X:=0;
loop	begin
	if (RT(X)&127) = ^* then
		\OUTPUT CONJUGATED LINE IN PLACE OF ASTERISK
		begin
		Y:=0;
		if LINECJ(0) #(^  !128) then
			while LINECJ(Y+1)# (^ !128) do
				[CHOUT(TV,LINECJ(Y));
				CHOUT(PR,LINECJ(Y));
				Y:=Y+1]
		end
	else [CHOUT(TV,RT(X)&127); CHOUT(PR,RT(X)&127)];
	if RT(X) >=128 then quit;
	X:=X+1;
	end;
CRLF(TV); CRLF(PR);
end;


proc	REMEMBER;
\KEY WORD IS "MY".  APPEND CONJUGATED LINE TO MEMORY PHRASE &
\CHANGE ENTRY IN REPLY TABLE (UNDER NOKEYFOUND) TO POINT TO IT.
\INPUTS: MEMPTR, LINECJ
int	X;
addr	A;
begin
\APPEND LINE
A:=MEMTB3(MEMPTR);
X:=0;
while LINECJ(X)# (^ !128) do [A(X):=LINECJ(X); X:=X+1];
A(X):=LINECJ(X);
\ CHANGE REPLY TABLE POINTER
REPTBL(MEMTB5(MEMPTR)):=MEMTBL(MEMPTR);
\ BUMP MEMPTR
MEMPTR:=MEMPTR+1;
if MEMPTR >=3 then MEMPTR:=0;
end;


begin	\MAIN PROC
KEYS:=97; REPS:=159; REPGPS:=37; CNJS:=40;
LINE:= RESERVE(65); LINECJ:=RESERVE(80);
KEYTBL:=RESERVE(KEYS*INTSIZE); RTBL:=RESERVE(KEYS);
REPTBL:=RESERVE(REPS*INTSIZE);
RXTBL:=RESERVE(REPGPS); SXTBL:=RESERVE(REPGPS);
CNJTBL:=RESERVE(CNJS*INTSIZE);
MEMTBL:=RESERVE(3*INTSIZE); MEMTB3:=RESERVE(3*INTSIZE); MEMTB5:=RESERVE(3);

SETUP;
A:="HELLO!
PLEASE TELL ME ABOUT YOUR PROBLEMS.";
CRLF(TV); TEXT(TV,A); CRLF(TV); CRLF(PR); TEXT(PR,A); CRLF(PR);
loop	begin
	INPUT;
	SCAN;
	if KEY = \BYE\5 then quit;
	if EQUAL then CONJUGATE;
	REPLY;
	if KEY = \MY\59 then REMEMBER;
	if KEY < \BYE = HELLO ETC.\5 then SETUP;
	end;
A:="I HOPE I^'VE BEEN SOME HELP TO YOU.  GOOD BYE.";
TEXT(TV,A); CRLF(TV); TEXT(PR,A); CRLF(PR);
end;	\OF ALL

