\KNTSTOUR.XPL	20-APR-2005
\Translation of Jim Phillip's translation of the knight's tour problem.
\Modified slightly for D16 (Original was NOV-17-1992).
\See "Algorithms + Data Structures = Programs" by Niklaus Wirth.

\The knight's tour problem is to start a knight somewhere on a chess board
\ and visit every square only once.

\This program uses recursive backtracking.

\It is fun to watch the H array while the program runs.

\   Ŀ   From a given position on a chess board the
\        2       1         Knight has 8 legal moves numbered 0 - 7.
\   Ĵ
\    3               0  
\   Ĵ   Move 0 has an X value of
\           Knt            2 and a Y value of 1.
\   Ĵ   Move 5 has an X value of -1 and
\    4               7     a Y value of -2.
\   Ĵ   These moves are represented in the constant
\        5       6         arrays, LegalX and LegalY
\   

inc	D16CODES;

int	N, NSQ;		\Length of side, and length squared
int	I, J, Q;
int	H(24,24);	\Boolean array "two-dimensional" N by N
int	LegalX, LegalY;	\Array of legal moves



func	Try(I, X, Y);
int	I, X, Y;
int	K, U, V;
begin
for K:= 0, 7 do
	begin
	U:= X + LegalX(K);		\U and V get next square
	V:= Y + LegalY(K);
	if H(U, V) = 0 then		\if square has not been visited
		begin
		H(U, V):= I;		\mark square with sequence number
		if I = NSQ then return true;
		if Try(I+1, U, V) then return true	\lead to solution?
		else H(U, V):= 0;	\No? restore virginity
		end;
	end;
return false;
end;	\Try



begin	\Main
for I:= 0, 24-1 do		\Set up border for speed
    for J:= 0, 24-1 do
	H(I, J):= 1;

for I:= 0, 24-1 do		\Move H to H(2,2)
	H(I):= H(I) + 2*2;
H:= H + 2*2;

LegalX:= [2, 1, -1, -2, -2, -1, 1, 2];
LegalY:= [1, 2, 2, 1, -1, -2, -2, -1];

Text(0, "Enter length of chess board: ");
N:= Intin(0);
if N > 20 then
	begin
	Text(0, "Sorry, chess board is larger than 20 x 20.
");
	exit;
	end;

NSQ:= N * N;

for I:= 0, N-1 do
    for J:= 0, N-1 do
	H(I, J):= 0;	\Initalize two-dimensional array

H(0, 0):= 1;		\Seed location 0,0 to be origin
Q:= Try(2, 0, 0);	\Start recursion looking for square 2 from X,Y = 0,0

if Q then		\Draw chess board with knight move sequence
	begin
	for I:= 0, N-1 do
		begin
		for J:= 0, N-1 do
			begin
			if H(I, J) < 10 then Chout(0, ^ );
			Intout(0, H(I, J));
			Text(0, "   ");
			end;
		Crlf(0);
		end;
	end
else	Text(0, "No Solution
");
end;	\Main
