\PI.XPL		NOV-07-90
\PI CALCULATOR
\BY RICHARD WILLMORE
\OCT-18-86, MODIFIED FOR AMIGA AND MAC II.
\NOV-07-90, MODIFIED FOR PC.

code	REM=2, RESERVE=3, CHIN=7, CHOUT=8, CRLF=9,
	INTIN=10, INTOUT=11, TEXT=12, OPENO=14, CLOSE=15;

int	DEV;		\OUTPUT DEVICE NUMBER

integer	NOTDONE, TRUE, FALSE;
integer SIZE, SIGN, PASS, EXP, NUM;
addr	TERM, RESULT, POWER, CONSTANT;



procedure OUTPUT(DIGITS);
addr DIGITS;
integer I;
begin
INTOUT(DEV,DIGITS(0)); TEXT(DEV,".");
for I:=1, SIZE do INTOUT(DEV,DIGITS(I));
CRLF(DEV);
end;	\OUTPUT



procedure DIV (DIVISOR, POINT);
\POINT:=POINT/DIVISOR
integer DIVISOR; 
addr POINT;
integer DIGIT, PLACE, QUOTIENT, RESIDUE;
begin
DIGIT:=0; NOTDONE:=FALSE;
for PLACE:=0, SIZE do
	begin DIGIT:=DIGIT + POINT(PLACE);
	QUOTIENT:=DIGIT/DIVISOR;
	\RESIDUE:=REM(1);
	RESIDUE:=rem(0);
	NOTDONE:=NOTDONE ! QUOTIENT ! RESIDUE;
	POINT(PLACE):=QUOTIENT;
	DIGIT:= 10*RESIDUE;
	end;
end;	\DIV



procedure ADD (TERM, TOTAL);		\TOTAL:=TOTAL+TERM
addr TERM, TOTAL;
integer SUM, CARRY, P, PLACE;
begin CARRY:=0;
for P:=0,SIZE do
	begin PLACE:=SIZE-P;
	SUM:=TOTAL(PLACE)+TERM(PLACE)+CARRY;
	if SUM>=10 then [SUM:=SUM-10; CARRY:=1]
		else CARRY:=0;
	TOTAL(PLACE):=SUM
	end;
end;	\ADD



procedure SUB (TERM, TOTAL);	\TOTAL:=TOTAL-TERM
addr TERM, TOTAL;
integer DIFF, LOAN, P, PLACE;
begin LOAN:=0;
for P:=0, SIZE do
	begin PLACE:=SIZE-P;
	DIFF:=TOTAL(PLACE)-TERM(PLACE)-LOAN;
	if DIFF<0 then [DIFF:=DIFF+10; LOAN:=1] else LOAN:=0;
	TOTAL(PLACE):=DIFF
	end
end;	\SUB



procedure COPY (SOURCE, DEST);
\DEST:=SOURCE
addr SOURCE, DEST;
integer I;
for I:=0, SIZE do DEST(I):=SOURCE(I);



procedure CHANGE (STRING);
\change ascii string to digit string
addr STRING;
integer I;
for I:=0, SIZE do STRING(I):=STRING(I)-^0;



procedure ROUNDOFF(PLACES, STRING);
integer PLACES;
addr STRING;
integer I;
begin for I:=0, SIZE do TERM(I):=0;
TERM(PLACES+1):=5;
ADD(TERM, STRING);
end;



procedure INIT;	  
integer I;
begin for I:=0, SIZE do
	begin POWER(I):=0;
	TERM(I):=0;
	if PASS=1 then RESULT(I):=0;
	end;

if PASS=1 then 		\POWER:=16/5
	begin POWER(0):=16;
	DIV (5, POWER);
	SIGN:=1
	end
else 		\PASS=2  POWER:=4/239
	begin POWER(0):=4;
	DIV (239, POWER);
	SIGN:=-1
	end;
EXP:=1; NOTDONE:=TRUE;
end;	\INIT



procedure PI;
begin
POWER:=RESERVE(SIZE+1);
TERM:=RESERVE(SIZE+1);
RESULT:=RESERVE(SIZE+1);

CONSTANT:=RESERVE(3);
CONSTANT(1):=25; CONSTANT(2):=239;

for PASS:=1,2 do
	begin INIT;
	while NOTDONE do
		begin
		COPY(POWER, TERM);  \RESULT:=RESULT (+/-) POWER/EXP
		DIV(EXP, TERM);
		if SIGN>0 then ADD(TERM, RESULT)
			else SUB(TERM, RESULT);
	
\		TEXT(DEV,"PASS "); INTOUT(DEV,PASS);
\		TEXT(DEV,"	"); OUTPUT(RESULT);

		EXP:=EXP+2; SIGN:=(-SIGN);
		DIV(CONSTANT(PASS), POWER);  \POWER:=POWER/(CONSTANT ^ 2)
		if PASS = 2  then DIV(CONSTANT(2), POWER);
		\CONSTANT(1) is already squared
		end \of while stmnt
	end; \of for stmnt

ROUNDOFF(NUM, RESULT); SIZE:=NUM;
TEXT(DEV,"THE VALUE OF PI TO "); INTOUT(DEV,NUM);
TEXT(DEV," PLACES IS: "); CRLF(DEV); OUTPUT(RESULT)
end; \of procedure PI



begin \main program
TRUE:=(1=1); FALSE:=(1=0);

\TEXT(0,"OUTPUT DEVICE (0-7)? ");
\DEV:=INTIN(0);
DEV:= 0;
OPENO(DEV);

loop	begin
	TEXT(0,"HOW MANY DIGITS WOULD YOU LIKE? ");
	NUM:=INTIN(0);
	if NUM<=0 then quit;
	SIZE:=NUM+NUM/10 + 1;
	PI;
	CRLF(DEV);
	end;
CLOSE(DEV);
end;	\MAIN
